angular.module('iclan', ['ionic', 'ngMap', 'ngMask', 'ngMessages', 'ngCordova', 'ngCordovaOauth', 'checklist-model',
    'iclan.loginController',
    'iclan.senhaController',
    'iclan.cadastroController',
    'iclan.selecaoController',
    'iclan.mapaController',
    'iclan.semHabilitacaoController',
    'iclan.comHabilitacaoController',
    'iclan.novaCNHController',
    'iclan.novoCarroController',
    'iclan.configuracaoController',
    'iclan.perfilController',
    'iclan.facebookController',
    'iclan.agendateoricoController',
    'iclan.calendarioteoricoController',
    'iclan.aulaspraticasController',
    'iclan.simuladorController',
    'iclan.principalController',
    'iclan.tabperfilController',
    'iclan.tabmenuController',
    'iclan.directives',
    'iclan.factories',
    'iclan.services'

    /*,'ngOpenFB']*/
])

.run(function($ionicPlatform, $rootScope, $location, $window, externalFactory, pushNotification, setBackButton) {

    $ionicPlatform.ready(function() {

        if (window.StatusBar) {
            StatusBar.overlaysWebView(false);
        }

        $rootScope.deviceWidth = "";

        if (screen.width > 1439) {
            $rootScope.deviceWidth = "1440";
        }
    });

    setBackButton.init();

    $rootScope.go = function(path) {
        if (path != $location.url())
            $location.url(path);
        else
            $window.location.reload();
    };

    $rootScope.back = function(path) {
        $window.history.back();
    };

    $rootScope.isWebDebug = function() {
        return ($location.host() == "localhost" || //pc-guilherme
                $location.host() == "192.168.0.18") //pc-matheus
    };

    $rootScope.getHash = function() {
        return $location.hash();
    };

    $rootScope.setHash = function(hash) {
        $location.hash(hash);
    };
})

//.constant("LINK", "http://192.168.0.250/iclan_admin/admin/api/1.5")
//.constant("LINK", "http://w3host.no-ip.org:8080/iclan_admin/admin/api/1.5")
.constant("LINK", "http://www.cfcmobile.com.br/admin/api/2.3")
    //.constant("LINK", "http://192.168.1.90/iclan_admin/admin/api/2.3")
    .constant("platform", ionic.Platform.platform().substring(0, 1).toUpperCase())
    .constant("versionOS", ionic.Platform.version())
    .constant("versionApp", "1.6.6")

.config(function($stateProvider, $urlRouterProvider) {

    //$urlRouterProvider.otherwise('principal');

    $stateProvider

        .state('principal', {
        url: '/principal',
        templateUrl: 'templates/principal.html',
        controller: 'principalController'
    })

    .state('login', {
        url: '/login',
        templateUrl: 'templates/login.html',
        controller: 'loginController'
    })

    .state('senha', {
        url: '/senha',
        templateUrl: 'templates/senha.html',
        controller: 'senhaController'
    })

    .state('selecao', {
        url: '/selecao',
        templateUrl: 'templates/selecao.html',
        controller: 'selecaoController'
    })

    .state('cadastro', {
        url: '/cadastro',
        templateUrl: 'templates/cadastro.html',
        controller: 'cadastroController'
    })

    .state('mapa', {
        cache: false,
        url: '/mapa',
        templateUrl: 'templates/mapa.html',
        controller: 'mapaController'
    })

    .state('semHabilitacao', {
        cache: false,
        url: '/semHabilitacao',
        templateUrl: 'templates/semHabilitacao.html',
        controller: 'semHabilitacaoController'
    })

    .state('comHabilitacao', {
        cache: false,
        url: '/comHabilitacao',
        templateUrl: 'templates/comHabilitacao.html',
        controller: 'comHabilitacaoController'
    })

    .state('novaCNH', {
        cache: false,
        url: '/novaCNH',
        templateUrl: 'templates/novaCNH.html',
        controller: 'novaCNHController'
    })

    .state('novoCarro', {
        cache: false,
        url: '/novoCarro',
        templateUrl: 'templates/novoCarro.html',
        controller: 'novoCarroController'
    })

    .state('configuracao', {
        cache: false,
        url: '/configuracao',
        templateUrl: 'templates/configuracao.html',
        controller: 'configuracaoController'
    })

    .state('perfil', {
        cache: false,
        url: '/perfil',
        templateUrl: 'templates/perfil.html',
        controller: 'perfilController'
    })

    .state('facebook', {
        cache: false,
        url: '/facebook',
        templateUrl: 'templates/facebook.html',
        controller: 'facebookController'
    })

    .state('agendateorico', {
        cache: false,
        url: '/agendateorico',
        templateUrl: 'templates/agendateorico.html',
        controller: 'agendateoricoController'
    })

    .state('calendarioteorico', {
        cache: false,
        url: '/calendarioteorico',
        templateUrl: 'templates/calendarioteorico.html',
        controller: 'calendarioteoricoController'
    })

    .state('aulaspraticas', {
        cache: false,
        url: '/aulaspraticas',
        templateUrl: 'templates/aulaspraticas.html',
        controller: 'aulaspraticasController'
    })

    .state('simulador', {
        cache: false,
        url: '/simulador',
        templateUrl: 'templates/simulador.html',
        controller: 'simuladorController'
    })

    .state('tabperfil', {
        cache: false,
        url: '/tabperfil',
        templateUrl: 'templates/tabperfil.html',
        controller: 'tabperfilController'
    })

    .state('tabmenu', {
        cache: false,
        url: '/tabmenu',
        templateUrl: 'templates/tabmenu.html',
        controller: 'tabmenuController'
    })

    //    switch(JSON.parse(localStorage.getItem('br.com.iclan_Pagina'))) {
    //        case "selecao":
    //            $urlRouterProvider.otherwise('/selecao');
    //        break;
    //        case "mapa":
    //            $urlRouterProvider.otherwise('/mapa');
    //        break;
    //        case "semHabilitacao":
    //            $urlRouterProvider.otherwise('/semHabilitacao');
    //        break;
    //        case "comHabilitacao":
    //            $urlRouterProvider.otherwise('/comHabilitacao');
    //        break;
    //        case "novaCNH":
    //            $urlRouterProvider.otherwise('/comHabilitacao');
    //        break;
    //        case "novoCarro":
    //            $urlRouterProvider.otherwise('/comHabilitacao');
    //        break;
    //        default:
    //            $urlRouterProvider.otherwise('/login');
    //        break;
    //  }
    

    $urlRouterProvider.otherwise('/principal');
});
