angular.module('iclan.agendateoricoController', [])

        .filter('range', function () {
            return function (input, idcategoria) {
                var output = [];
                angular.forEach(input, function (value, key) {

                    if (value.IdCategoriaAgenda == idcategoria) {
                        // angular.forEach(value, function (value, key) {
                        output.push(value);
                        // });
                    }
                });
                return output;
            };
        })

        .filter('time', function () {
            return function (input, splitChar, splitIndex) {
                // do some bounds checking here to ensure it has that index
                return input.split(splitChar)[splitIndex];
            }
        })

        .filter('datasimples', function () {
            return function (input) {
                var retArray = input.split("/");
                if (retArray[0] == "") {
                    return "";
                } else {
                    return retArray[0] + "/" + retArray[1] + "/" + retArray[2].substring(2, 4);
                }
            }
        })

        .controller('agendateoricoController', ['$scope', '$ionicLoading', '$ionicPopup', '$cordovaPush', 'externalFactory', 'localFactory', 'platform', 'registerFactory', '$ionicScrollDelegate', '$location', '$ionicPopup',
            function ($scope, $ionicLoading, $ionicPopup, $cordovaPush, externalFactory, localFactory, platform, registerFactory, $ionicScrollDelegate, $location, $ionicPopup) {

                var day_of_week = new Array('Dom', 'Seg', 'Ter', 'Qua', 'Qui', 'Sex', 'Sab');
                var month_of_year = new Array('Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro');

                var Calendar = new Date();

                var year = Calendar.getFullYear();       // Retorna o ano
                var month = Calendar.getMonth();    // Retorna mes (0-11)
                var today = Calendar.getDate();     // Retorna dias (1-31)
                var weekday = Calendar.getDay();   // Retorna dias (1-31)
                var DAYS_OF_WEEK = 7;    // "constant" para o numero de dias na semana
                var DAYS_OF_MONTH = 31;    // "constant" para o numero de dias no mes

                Calendar.setDate(1);    // Comecar o calendario no dia '1'
                Calendar.setMonth(month);    // Comecar o calendario com o mes atual

                $scope.meses = [];
                $scope.semana = [];
                $scope.ano = year;
                $scope.mesAtual = ("0" + (month + 1)).slice(-2);
                $scope.diaAtual = today;

                $scope.modulos = "";

                $scope.carregar = function () {
                    //buildMonth();
                    listaModulos();
                }
                function buildMonth() {
                    for (index = 0; index < Calendar.getDay(); index++) {
                        $scope.semana.push("");
                    }

                    for (index = 0; index < DAYS_OF_MONTH; index++)
                    {
                        if (Calendar.getDate() > index)
                        {
                            week_day = Calendar.getDay();
                            if (week_day == 0) {

                            }
                            if (week_day != DAYS_OF_WEEK)
                            {
                                var day = Calendar.getDate();
                                // if (today == Calendar.getDate()) {
                                //cal += highlight_start + day + highlight_end + TD_end;
                                // } else {
                                $scope.semana.push(String(day));
                                // }
                            }
                            if (week_day == DAYS_OF_WEEK - 1) {
                                $scope.meses.push($scope.semana);
                                $scope.semana = [];
                            }
                        }
                        Calendar.setDate(Calendar.getDate() + 1);
                        //$scope.mes.push($scope.semana);
                    }
                    console.log($scope.meses);
                    getEvent();
                }

                function listaModulos() {

                    $ionicLoading.show({
                        template: 'Carregando módulos ...'
                    });

                    var data = {
                        IdCFC: localFactory.get("Dados.IdEmpresa"),
                        key: localFactory.get("key")
                    };

                    externalFactory.post("/buscar-modulos-teoricos", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                                $ionicLoading.hide();
                            }).success(function (retorno) {
                        console.log(retorno);
                        if (!retorno.error) {
                            $scope.modulos = retorno.Modulos;
                            $scope.dadosagendamentos = retorno.DadosAgendamento;
                        }

                        $ionicLoading.hide();

                    });
                }

                function getEvent() {

                    $scope.solicitacoes = "";

                    $ionicLoading.show({
                        template: 'Carregando horários ...'
                    });

                    var data = {
                        IdCFC: localFactory.get("Dados.IdEmpresa"),
                        key: localFactory.get("key")
                    };

                    externalFactory.post("/buscar-eventos-agenda-teorico", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                                $ionicLoading.hide();
                            }).success(function (retorno) {
                        console.log(retorno);
                        if (!retorno.error) {
                            $scope.solicitacoes = retorno.Solicitacoes;
                        }

                        $ionicLoading.hide();

                    });
                }


                $scope.scrollTo = function (anchor) {
                    $location.hash(anchor);
                    $ionicScrollDelegate.anchorScroll(true);
                };

                $scope.goConfiguracao = function () {
                    $scope.go("/configuracao");
                }

                $scope.goCalendarioTeorico = function () {
                    $scope.go("/calendarioteorico");
                }

                $scope.refresh = function () {
                    $scope.go("/agendateorico");
                }

                $scope.clickItem = function (idagenda, datainicio, status, horainicio, horafim) {
                    if (idagenda) {
                        $scope.showPopUp(idagenda, datainicio, status, horainicio, horafim);
                    } else {
                        $scope.goCalendarioTeorico();

                    }
                }


                $scope.showPopUp = function (idagenda, datainicio, status, horainicio, horafim) {
                    if (status == 'E') {
                        var titulo = 'Agendamento';
                        var template = 'Agendamento ' + datainicio + ' ' + horainicio + '-' + horafim + '?';
                        var flag = 1;
                    } else {
                        var titulo = 'Excluir';
                        var template = 'Excluir agendamento ' + datainicio + ' ' + horainicio + '-' + horafim + '?';
                        var flag = 0;
                    }

                    var confirmPopup = $ionicPopup.confirm({
                        title: titulo,
                        template: template
                    });

                    confirmPopup.then(function (res) {
                        if (res) {
                            if (flag == 0) {
                                deletaAgendamento(idagenda);
                            }
                        } else {
                            console.log('You are not sure');
                        }
                    });
                };

                function deletaAgendamento(idagenda) {

                    var data = {
                        key: localFactory.get("key"),
                        IdAgendaPessoa: idagenda
                    };

                    externalFactory.post("/deletar-agendamento", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                            }).success(function (retorno) {
                        console.log(retorno);
                        if (retorno.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: retorno.error
                            });

                        } else {
                            $scope.refresh();
                        }
                    });
                }

                $scope.timeline = function () {
                    $scope.go("/semHabilitacao");
                }


            }]);




