angular.module('iclan.cadastroController', [])

.controller('cadastroController', ['$scope', '$ionicLoading', '$ionicPopup', '$cordovaPush', 'externalFactory', 'localFactory', 'platform', 'registerFactory',
    function($scope, $ionicLoading, $ionicPopup, $cordovaPush, externalFactory, localFactory, platform, registerFactory) {

        var vm = this;


        vm.cadastrar = cadastrar;
        vm.voltarLogin = voltarLogin;

        function cadastrar() {

            if (vm.nome && vm.email && vm.senha && vm.confirmacaoSenha) {
                $ionicLoading.show({
                    template: 'Cadastrando ...'
                });

                var data = {
                    nome: vm.nome,
                    email: vm.email,
                    senha: vm.senha
                };

                externalFactory.post("/cadastro", data, "options")
                    .then(
                        function(response) {
                            var data = response.data;

                            if (data.Mensagem != 'OK') {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: data.Mensagem
                                });
                            } else {
                                angular.forEach(data.Pessoa, function(value, key) {
                                    localFactory.set('Dados.' + key, value);
                                });

                                localFactory.set("key", data.key);

                                if (!$scope.isWebDebug()) {
                                    var config;

                                    switch (platform) {
                                        case "I":
                                            config = {
                                                "alert": true,
                                                "badge": true,
                                                "sound": true
                                            };
                                            break;
                                        case "A":
                                            config = {
                                                "senderID": "821213821567"
                                            };
                                            break;
                                    }

                                    document.addEventListener("deviceready", function() {
                                        $cordovaPush.register(config).then(function(result) {
                                            registerFactory.saveID(result);
                                            localFactory.set("RegisterID", result);
                                        }, function(error) {
                                            $ionicPopup.alert({
                                                title: "Atenção",
                                                template: "Erro ao registrar-se no servidor de push."
                                            });
                                        });
                                    }, false);
                                }

                                localFactory.set('Logado', true);
                                $scope.go("/principal");
                            }

                            $ionicLoading.hide();
                        },
                        function(error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: "Não foi possível conectar-se ao servidor."
                            });
                            $ionicLoading.hide();
                        }
                    )
            }
        }

        function voltarLogin() {
            $scope.go("/tabperfil");
        }
    }
]);
