angular.module('iclan.calendarioteoricoController', [])

        .filter('buscaData', function () {
            return function (input, dia, mes, ano) {
                var output = [];
                dia = ("0" + (dia)).slice(-2);
                angular.forEach(input, function (value, key) {

                    if (key == dia + '/' + mes + '/' + ano) {
                        angular.forEach(value, function (value, key) {
                            output.push(value);
                        });
                    }
                });
                return output;
            };
        })

        .controller('calendarioteoricoController', ['$scope', '$ionicLoading', '$ionicPopup', '$cordovaPush', 'externalFactory', 'localFactory', 'platform', 'registerFactory', '$ionicScrollDelegate', '$location', '$ionicModal', '$filter',
            function ($scope, $ionicLoading, $ionicPopup, $cordovaPush, externalFactory, localFactory, platform, registerFactory, $ionicScrollDelegate, $location, $ionicModal, $filter) {

                var day_of_week = new Array('Dom', 'Seg', 'Ter', 'Qua', 'Qui', 'Sex', 'Sab');
                $scope.month_of_year = new Array('Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro');

                var Calendar = new Date();

                var year = Calendar.getFullYear();       // Retorna o ano
                var month = Calendar.getMonth();    // Retorna mes (0-11)
                var today = Calendar.getDate();     // Retorna dias (1-31)
                var weekday = Calendar.getDay();   // Retorna dias (1-31)
                var DAYS_OF_WEEK = 7;    // "constant" para o numero de dias na semana
                var DAYS_OF_MONTH = 31;    // "constant" para o numero de dias no mes

                Calendar.setDate(1);    // Comecar o calendario no dia '1'
                Calendar.setMonth(month);    // Comecar o calendario com o mes atual

                $scope.meses = [];
                $scope.semana = [];
                $scope.ano = year;
                $scope.mesAtual = ("0" + (month + 1)).slice(-2);
                $scope.mesAtualNum = month;
                $scope.mesInicial = month;
                $scope.diaAtual = today;
                $scope.diaSelecionado = '';

                $scope.solicitacoes = "";



                $scope.carregar = function () {
                    buildMonth();
                }

                $scope.anterior = function () {
                    month = month - 1;
                    Calendar.setMonth(month);
                    Calendar.setDate(1);
                    $scope.mesAtual = ("0" + (month + 1)).slice(-2);
                    $scope.ano = Calendar.getFullYear();
                    buildMonth();
                    $scope.mesAtualNum = month;
                }

                $scope.proximo = function () {
                    month = month + 1;
                    if (month > 11) {
                        month = 0;
                    }
                    Calendar.setMonth(month);
                    Calendar.setDate(1);
                    $scope.mesAtual = ("0" + (month + 1)).slice(-2);
                    $scope.ano = Calendar.getFullYear();
                    buildMonth();
                    $scope.mesAtualNum = month;
                }

                function buildMonth() {
                    $scope.meses = [];
                    $scope.semana = [];
                    for (index = 0; index < Calendar.getDay(); index++) {
                        $scope.semana.push("");
                    }

                    for (index = 0; index < DAYS_OF_MONTH; index++)
                    {
                        if (Calendar.getDate() > index)
                        {
                            week_day = Calendar.getDay();
                            if (week_day == 0) {

                            }
                            if (week_day != DAYS_OF_WEEK)
                            {
                                var day = Calendar.getDate();
                                // if (today == Calendar.getDate()) {
                                //cal += highlight_start + day + highlight_end + TD_end;
                                // } else {
                                $scope.semana.push(String(day));
                                // }
                            }
                            if (week_day == DAYS_OF_WEEK - 1) {
                                $scope.meses.push($scope.semana);
                                $scope.semana = [];
                            }
                        }
                        Calendar.setDate(Calendar.getDate() + 1);
                        //$scope.mes.push($scope.semana);
                    }
                    if ($scope.semana) {
                        $scope.meses.push($scope.semana);
                        $scope.semana = [];
                    }
                    console.log($scope.meses);
                    getEvent();
                }

                function getEvent() {



                    $ionicLoading.show({
                        template: 'Carregando horários ...'
                    });

                    var data = {
                        IdCFC: localFactory.get("Dados.IdEmpresa"),
                        key: localFactory.get("key")
                    };

                    externalFactory.post("/buscar-eventos-agenda-teorico", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                                $ionicLoading.hide();
                            }).success(function (retorno) {
                        console.log(retorno);
                        if (!retorno.error) {
                            $scope.solicitacoes = retorno.Solicitacoes;

                        }

                        $ionicLoading.hide();

                    });
                }

                $ionicModal.fromTemplateUrl('templates/modais/marcateorico.html', {
                    scope: $scope,
                }).then(function (modal) {
                    $scope.modal = modal
                });

                $scope.showHorarios = function (item) {
                    $scope.diaSelecionado = item;
                    $scope.modal.show();
                }

                $scope.hideHorarios = function () {
                    $scope.horarios = null;
                    $scope.modal.hide();
                };

                $scope.goAgendaTeorico = function () {
                    $scope.go("/agendateorico");
                }

                var data, horarioInscricao;

                $scope.seleciona = function (horario) {
                    data = {
                        IdPessoa: localFactory.get("Dados.IdPessoa"),
                        IdCFC: $scope.cfc.IdEmpresa,
                        key: localFactory.get("key")
                    };
                    horarioInscricao = {
                        Horarios: [horario],
                        IdPessoa: "",
                        Status: "A"
                    };
                    $scope.botaoSolicitar = true;
                };

                $scope.ni_toggle = Array();


                $scope.solicitar = function () {

                    $scope.horarios_aux = $filter('buscaData')($scope.solicitacoes, $scope.diaSelecionado, $scope.mesAtual, $scope.ano);
                    $scope.horariosFinal = [];

                    angular.forEach($scope.horarios_aux, function (value, key) {
                        if ($scope.ni_toggle[value.IdAgenda]) {
                            $scope.horariosFinal.push(value);
                        }

                    });

                    if ($scope.horariosFinal.length) {


                        $ionicLoading.show({
                            template: "Agendando ..."
                        });

                        var data = {
                            IdCFC: localFactory.get("Dados.IdEmpresa"),
                            key: localFactory.get("key"),
                            Horarios: $scope.horariosFinal,
                            Status: "A"
                        };

                        externalFactory.post("/solicitar-agendamento-aula-teorica", data, "options")

                                .error(function (error) {
                                    $ionicPopup.alert({
                                        title: "Atenção",
                                        template: "Não foi possível conectar-se ao servidor."
                                    });
                                    $ionicLoading.hide();
                                }).success(function (retorno) {
                            console.log(retorno);
                            if (retorno.error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: retorno.error
                                });
                            } else {
                                $scope.modal.hide();
                                $scope.go("/agendateorico");
                            }
                            $ionicLoading.hide();
                        });
                    }

                };


                $scope.buscaList = [
                    {text: "Manhã", checked: false},
                    {text: "Tarde", checked: false},
                    {text: "Noite", checked: false}
                ];

                $scope.dataagora = {
                    value: new Date()
                };

            }]);




