angular.module('iclan.comHabilitacaoController', [])

        .controller('comHabilitacaoController', ['$scope', '$ionicLoading', '$ionicModal', '$ionicPopup', '$ionicScrollDelegate', 'externalFactory', 'localFactory', 'backButtonFactory',
            function ($scope, $ionicLoading, $ionicModal, $ionicPopup, $ionicScrollDelegate, externalFactory, localFactory, backButtonFactory) {

                var vm = this;

                vm.init = init;
                vm.carregar = carregar;
                vm.irConfiguracao = irConfiguracao;
                vm.irNovaCNH = irNovaCNH;
                vm.irNovoCarro = irNovoCarro;

                vm.deletar = deletar;
                vm.init();
                vm.carregar();

                function init() {

                    localFactory.set("Pagina", "comHabilitacao");

                    if (window.StatusBar) {
                        StatusBar.overlaysWebView(false);
                    }

                    vm.temCNH = true;

                    if (!localFactory.get("Tab")) {
                        vm.tab = 1;
                    } else {
                        vm.tab = localFactory.get("Tab");
                        localFactory.delete("Tab");
                    }

                    localFactory.set("Habilitado", true);

                    vm.habilitado = localFactory.get("Habilitado");

                    vm.placa2 = "";
                    vm.renavam = "";
                    vm.cnh = "";
                }

                function carregar() {

                    vm.carregando = true;
                    vm.semRegistro = true;

                    vm.NenhumCarrosComNotificacao = true;
                    vm.NenhumCarrosSemNotificacao = true;

                    vm.esconderCarrosSemNotificacao = true;

                    vm.itensCom = "";
                    vm.itensSem = "";

                    switch (vm.tab) {
                        case 1:

                            localFactory.set("Tab", 1);

                            $ionicLoading.show({
                                template: 'Carregando CNH ...'
                            });

                            vm.mensagem = "Não existe CNH cadastrada.";

                            var data = {
                                key: localFactory.get("key")
                            };

                            externalFactory.post("/buscar-carteira-multas", data, "options")

                                    .error(function (error) {
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Não foi possível conectar-se ao servidor."
                                        });
                                        $ionicLoading.hide();
                                    }).success(function (retorno) {
                                $ionicLoading.hide();

                                if (!retorno.error) {
                                    if (retorno.status != "OK") {
                                        vm.semRegistro = false;
                                        if (retorno.status == "SemCNH") {
                                            vm.temCNH = false;
                                        }
                                    } else {
                                        if (angular.isUndefined(retorno.CNHComNotificacao)
                                                &&
                                                angular.isUndefined(retorno.CNHSemNotificacao)) {
                                            vm.semRegistro = false;
                                            vm.temCNH = false;
                                        } else {
                                            vm.semRegistro = true;
                                            vm.temCNH = true;
                                            vm.itensCom = retorno.CNHComNotificacao;
                                            vm.itensSem = retorno.CNHSemNotificacao;

                                            if (angular.isUndefined(retorno.Multas)) {
                                                vm.semMulta = false;
                                                vm.mensagemMultas = "Nenhuma multa no momento.";
                                            } else {
                                                vm.semMulta = true;
                                                vm.multasCNH = retorno.Multas;
                                            }
                                        }
                                        vm.carregando = false;
                                    }
                                } else {

                                }
                            });
                            break;
                        case 2:

                            localFactory.set("Tab", 2);

                            $ionicLoading.show({
                                template: 'Carregando veículos ...'
                            });

                            //msg geral
                            vm.mensagem = "Não existem carros cadastrados.";

                            var data = {
                                key: localFactory.get("key")
                            };

                            externalFactory.post("/buscar-carros", data, "options")
                                    .error(function (error) {
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Não foi possível conectar-se ao servidor."
                                        });
                                        $ionicLoading.hide();
                                    }).success(function (retorno) {
                                if (retorno.error) {
                                    $ionicLoading.hide();
                                    vm.semRegistro = false;
                                } else {
                                    $ionicLoading.hide();
                                    if (angular.isUndefined(retorno.CarrosComNotificacao)
                                            &&
                                            angular.isUndefined(retorno.CarrosSemNotificacao)) {
                                        vm.semRegistro = false;
                                    } else {
                                        vm.semRegistro = true;
                                        if (angular.isUndefined(retorno.CarrosComNotificacao)) {
                                            vm.NenhumCarrosComNotificacao = false;
                                        } else {
                                            vm.itensCom = retorno.CarrosComNotificacao;
                                        }
                                        if (!angular.isUndefined(retorno.CarrosSemNotificacao)) {
                                            vm.esconderCarrosSemNotificacao = false;
                                            vm.itensSem = retorno.CarrosSemNotificacao;
                                        }
                                    }

                                    vm.carregando = false;
                                }
                            });
                            break;
                    }
                }
                ;

                $scope.openModal = function (tab, item) {
                    switch (tab) {
                        case 1:
                            if (item.Dados == null || item.Dados == "") {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Estamos atualizando seus dados. Aguarde."
                                });
                            } else {
                                $scope.situacao = item;
                                $scope.showModal(0);
                            }
                            break;
                        case 2:
                            $ionicLoading.show({
                                template: "Buscando dados ..."
                            });

                            var data = {
                                key: localFactory.get("key"),
                                Renavam: item.Renavam
                            };

                            externalFactory.post("/buscar-carro-multas", data, "options")

                                    .error(function (error) {
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Não foi possível conectar-se ao servidor."
                                        });
                                        $ionicLoading.hide();
                                    }).success(function (retorno) {
                                if (retorno.error) {
                                    $ionicPopup.alert({
                                        title: "Atenção!",
                                        template: retorno.error
                                    });
                                    $ionicLoading.hide();
                                } else {
                                    if (!item.cidade) {
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Estamos atualizando seus dados. Aguarde."
                                        });
                                    } else {
                                        $scope.carro = item;
                                        $scope.NomeCarro = item.nome_carro;
                                        if (angular.isUndefined(retorno.Multas)) {
                                            vm.semMulta = false;
                                            vm.mensagemMultas = "Nenhuma multa no momento.";
                                        } else {
                                            vm.semMulta = true;
                                            vm.multas = retorno.Multas;
                                        }
                                        $scope.showModal(1);
                                    }
                                    $ionicLoading.hide();
                                }
                            });
                            break;
                        case 3:
                            $scope.dadosInfracao = item;
                            $scope.showModal(2);
                            break;
                    }
                };

                function deletar(item) {

                    var confirmPopup = $ionicPopup.confirm({
                        title: "Deseja remover este item?",
                        okText: "Sim",
                        cancelText: "Não"
                    });

                    confirmPopup.then(function (response) {

                        if (response) {

                            if (vm.tab == 1) {

                                $ionicLoading.show({
                                    template: "Removendo CNH ..."
                                });

                                var data = {
                                    key: localFactory.get("key"),
                                    IdCarteira: item.IdCarteira
                                };

                                externalFactory.post("/deletar-carteira", data, "options")

                                        .error(function (error) {
                                            $ionicPopup.alert({
                                                title: "Atenção",
                                                template: "Não foi possível conectar-se ao servidor."
                                            });
                                            $ionicLoading.hide();

                                        }).success(function (retorno) {

                                    if (retorno.error) {
                                        $ionicPopup.alert({
                                            title: "Atenção!",
                                            template: retorno.error
                                        });
                                    } else {
                                        vm.carregar();
                                    }
                                    $ionicLoading.hide();
                                });

                            } else {

                                $ionicLoading.show({
                                    template: "Removendo veículo ..."
                                });

                                var data = {
                                    key: localFactory.get("key"),
                                    IdCarro: item.IdCarro
                                };

                                externalFactory.post("/deletar-carro", data, "options")

                                        .error(function (error) {
                                            $ionicPopup.alert({
                                                title: "Atenção",
                                                template: "Não foi possível conectar-se ao servidor."
                                            });
                                        }).success(function (retorno) {
                                    if (retorno.error) {
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: retorno.error
                                        });
                                    } else {
                                        vm.carregar();
                                    }
                                });

                            }

                        }

                    });
                }
                ;


                $ionicModal.fromTemplateUrl('templates/modais/detalhesCNH.html', {
                    scope: $scope
                }).then(function (modal) {
                    $scope.detalhesCNH = modal
                });

                $ionicModal.fromTemplateUrl('templates/modais/detalhesVeiculo.html', {
                    scope: $scope
                }).then(function (modal) {
                    $scope.detalhesVeiculo = modal
                });

                $ionicModal.fromTemplateUrl('templates/modais/infracao.html', {
                    scope: $scope
                }).then(function (modal) {
                    $scope.infracao = modal
                });


                $scope.maskModals = function (idMask) {
                    var texto;

                    switch (idMask) {
                        case 1:
                            texto = this.cnh;
                            break;
                        case 2:
                            texto = this.placa1;
                            break;
                        case 3:
                            texto = this.placa2;
                            break;
                        case 4:
                            texto = this.renavam;
                            break;
                    }

                    angular.forEach(texto, function (value, key) {
                        if (idMask == 2) {  //placa1
                            if (value.match(/[a-zA-Z]/)) {
                                texto = texto.toUpperCase();
                            } else {
                                texto = texto.replace(value, "");
                            }
                        } else {
                            if (!value.match(/[0-9]/)) {
                                texto = texto.replace(value, "");
                            }
                        }
                    });

                    switch (idMask) {
                        case 1:
                            this.cnh = texto;
                            break;
                        case 2:
                            this.placa1 = texto;
                            break;
                        case 3:
                            this.placa2 = texto;
                            break;
                        case 4:
                            this.renavam = texto;
                            break;
                    }
                };


                $scope.showModal = function (page) {
                    switch (page) {
                        case 0:
                            backButtonFactory.setHash("1");
                            $scope.detalhesCNH.show();
                            break;
                        case 1:
                            backButtonFactory.setHash("1");
                            $scope.detalhesVeiculo.show();
                            break;
                        case 2:
                            backButtonFactory.setHash("1");
                            $scope.infracao.show();
                            break;
                    }
                }
                $scope.hideModal = function (page) {
                    switch (page) {
                        case 0:
                            backButtonFactory.removeHash();
                            $scope.detalhesCNH.hide();
                            break;
                        case 1:
                            backButtonFactory.removeHash();
                            $scope.detalhesVeiculo.hide();
                            break;
                        case 2:
                            backButtonFactory.removeHash();
                            $scope.infracao.hide();
                            break;
                    }
                };


                function irConfiguracao() {
                    $scope.go("/configuracao");
                }
                ;

                function irNovaCNH() {
                    $scope.go("/novaCNH");
                }

                function irNovoCarro() {
                    $scope.go("/novoCarro");
                }
                ;
                $scope.voltar = function () {
                    $scope.go("/tabmenu");
                }

//FUNCAO SAIR - FIM

            }]);
