angular.module('iclan.configuracaoController', [])

.controller('configuracaoController', function($scope, $ionicPopup, $ionicModal, $ionicLoading, externalFactory, localFactory, backButtonFactory) {

    localFactory.set("Pagina", "configuracao");

    $scope.habilitacao = localFactory.get("Dados.Habilitacao");

    $ionicModal.fromTemplateUrl('templates/modais/cfc.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.cfc = modal
    });

    $ionicModal.fromTemplateUrl('templates/modais/sobre.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.sobre = modal
    });

    $scope.action = function(num) {
        switch(num) {
            case 0:
                if(localFactory.get("Dados.Habilitacao") == "N") {
                    $scope.go("/semHabilitacao");
                } else {
                    $scope.go("/comHabilitacao");
                }
            break;
            case 1:
                $scope.go("/perfil");
            break;
            case 2:
                var data = {
                    key: localFactory.get("key")
                };

                $ionicLoading.show({
                    template: 'Buscando CFC...'
                });

                externalFactory.post("/buscar-cfc", data, "options")

                .error(function(error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: "Não foi possível conectar-se ao servidor."
                    });

                    $ionicLoading.hide();
                }).success(function(retorno) {

                    $ionicLoading.hide();

                    if(retorno.error) {
						
                        $ionicPopup.alert({
                            title: "Atenção",
                            template: retorno.error
                        });
						
                    } else {
                        $scope.dadosCFC = retorno;
                        localFactory.set("Dados.Renach", $scope.dadosCFC.CFC.Renach);

                        if(localFactory.get("Dados.Renach") == "" || localFactory.get("Dados.Renach") == null) {
                            $scope.alterarCFC = 1
                        } else {
                            $scope.alterarCFC = 2;
                        }

                        backButtonFactory.setHash("1");
                        $scope.cfc.show();
                    }
                });
            break;
            case 3:
                var data = {
                    key: localFactory.get("key"),
                    habilitado: false
                };

                externalFactory.post("/trocar-situacao-habilitado", data, "options")

                .error(function(error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: "Não foi possível conectar-se ao servidor."
                    });
                    $ionicLoading.hide();
                }).success(function(retorno) {
                    if(retorno.error) {
                        $ionicPopup.alert({
                            title: "Atenção",
                            template: retorno.error
                        });

                        $ionicLoading.hide();
                    } else {
                        localFactory.set("Dados.Habilitacao", "N");

                        if(localFactory.get("Dados.IdEmpresa") != null) {
                            $scope.go("/semHabilitacao");
                        } else {
                            $scope.go("/mapa");
                        }

                    }
                });
            break;
            case 4:
                var data = {
                    key: localFactory.get("key"),
                    habilitado: true
                };

                externalFactory.post("/trocar-situacao-habilitado", data, "options")

                .error(function(error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: "Não foi possível conectar-se ao servidor."
                    });
                    $ionicLoading.hide();
                }).success(function(retorno) {
                    if(retorno.error) {
                        $ionicPopup.alert({
                            title: "Atenção!",
                            template: retorno.error
                        });

                        $ionicLoading.hide();
                    } else {
                        localFactory.set("Dados.Habilitacao", "S");
                        $scope.go("/comHabilitacao");
                    }
                });
            break;
            case 5:
                backButtonFactory.setHash("1");
                $scope.sobre.show();
            break;
            case 6:
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Você tem certeza que deseja fazer logout?',
                    cancelText : 'Cancelar',
                    okText : 'Sim'
                });

                confirmPopup.then(function(res) {
                    if(res) {
                        localFactory.clear();
                        $scope.hideModal(0);
                        $scope.go('/login');
                        /*var data = {
                            RegisterID: localFactory.get("RegisterID")
                        };

                        externalFactory.post("/deleta-register-id", data, "options")

                        .error(function(error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: "Não foi possível conectar-se ao servidor."
                            });
                        }).success(function(retorno) {
                            var email = localFactory.get('Dados.Email');
                            localFactory.clear();
                            localFactory.set('Logado', false);
                            localFactory.set('Dados.Email', email);
                            $scope.hideModal(0);
                            $scope.go('/login');
                        });*/
                    }
                });
            break;
        }
    };
    $scope.hideModal = function(page) {
        switch(page) {
            case 0:
                backButtonFactory.removeHash();
                $scope.cfc.hide();
            break;
            case 1:
                backButtonFactory.removeHash();
                $scope.sobre.hide();
            break;
        }
    };

    $scope.trocarCFC = function() {
        $scope.hideModal(0);
        $scope.go("/mapa");
    }

});
