angular.module('iclan.facebookController', [])

        .controller('facebookController', ['$scope', '$http', '$ionicLoading', '$ionicPopup', '$cordovaPush', 'externalFactory', 'localFactory', 'platform', 'registerFactory'/*, 'ngFB'*/,
            function ($scope, $http, $ionicLoading, $ionicPopup, $cordovaPush, externalFactory, localFactory, platform, registerFactory/*, ngFB*/) {

                var vm = this;

                // Métodos
                vm.cadastrar = cadastrar;
                vm.voltarLogin = voltarLogin;


                $http.get('https://graph.facebook.com/v2.2/me?access_token=' + sessionStorage['fbAccessToken'] + '&fields=id,name,email&format=json').then(function (user) {
                    vm.nome = user.data.name;
                    vm.email = user.data.email;
                    $scope.user = {name: user.data.name, id: user.data.id};

                }, function (error) {

                });

                function cadastrar() {
                    if (vm.nome && vm.email) {
                        $ionicLoading.show({
                            template: 'Cadastrando ...'
                        });

                        var data = {
                            nome: vm.nome,
                            email: vm.email,
                            accessToken: sessionStorage['fbAccessToken']
                        }

                        externalFactory.post("/cadastrofacebook", data, "options")
                                .then(
                                        function (response) {
                                            var data = response.data;

                                            if (data.error) {
                                                $ionicPopup.alert({
                                                    title: "Atenção",
                                                    template: data.error
                                                });
                                            } else {
                                                angular.forEach(data.Pessoa, function (value, key) {
                                                    localFactory.set('Dados.' + key, value);
                                                });
                                                localFactory.set("key", data.key);
                                                localFactory.set('Logado', true);
                                                localFactory.set('ServicoSelecionado', data.ServicoSelecionado);

                                                if (!$scope.isWebDebug()) {
                                                    var config;

                                                    switch (platform) {
                                                        case "I":
                                                            config = {
                                                                "alert": true,
                                                                "badge": true,
                                                                "sound": true
                                                            };
                                                            break;
                                                        case "A":
                                                            config = {
                                                                "senderID": "821213821567"
                                                            };
                                                            break;
                                                    }

                                                    $cordovaPush.register(config).then(function (result) {
                                                        registerFactory.saveID(result);
                                                    }, function (error) {
                                                        $ionicPopup.alert({
                                                            title: "Atenção",
                                                            template: "Erro ao registrar-se no servidor de push."
                                                        });
                                                    });
                                                }

                                                localFactory.set('Logado', true);
                                                $scope.go("/principal");
                                            }

                                            $ionicLoading.hide();
                                        },
                                        function (error) {
                                            $ionicPopup.alert({
                                                title: "Atenção",
                                                template: "Não foi possível conectar-se ao servidor."
                                            });
                                            $ionicLoading.hide();
                                        }
                                )

                    }
                }

                function voltarLogin() {
                    $scope.go("/tabperfil");
                }
            }]);
