angular.module('iclan.loginController', [/*'ngOpenFB'*/'ngCordovaOauth'])

        .controller('loginController', ['$scope', '$http', '$ionicLoading', '$ionicPopup', '$cordovaPush', '$cordovaOauth', '$location', 'externalFactory', 'localFactory', 'platform', 'versionOS', 'versionApp', 'registerFactory',
            function ($scope, $http, $ionicLoading, $ionicPopup, $cordovaPush, $cordovaOauth, $location, externalFactory, localFactory, platform, versionOS, versionApp, registerFactory) {

                var vm = this;

                // Variáveis membro do controller
                vm.disable = false;

                // Métodos
                vm.logar = logar;
                vm.irCadastro = irCadastro;
                vm.irEsqueciSenha = irEsqueciSenha;

                // Inicialização


                if (localFactory.get("Dados.Email")) {
                    vm.email = localFactory.get("Dados.Email");
                }

                function loginFailed() {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: 'Login via facebook falhou.'
                    });
                }

                function logar() {

                    if (vm.email && vm.senha) {

                        vm.disable = true;

                        var data = {
                            Email: vm.email,
                            Senha: vm.senha
                        };

                        $ionicLoading.show({
                            template: 'Entrando ...'
                        });

                        externalFactory.post("/login", data, "options")

                                .error(function (error) {

                                    $ionicPopup.alert({
                                        title: "Atenção",
                                        template: "Não foi possível conectar-se ao servidor."
                                    });
                                    $ionicLoading.hide();

                                }).success(function (retorno) {
                            if (retorno.Mensagem != "OK") {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: retorno.Mensagem
                                });
                                $ionicLoading.hide();

                            } else {
                                angular.forEach(retorno.DadosUsuario, function (value, key) {
                                    localFactory.set('Dados.' + key, value);
                                });
                                localFactory.set("troca", retorno.troca);
                                localFactory.set("key", retorno.key);
                                localFactory.set('Logado', true);
                                localFactory.set('ServicoSelecionado', retorno.ServicoSelecionado);
                                $ionicLoading.hide();

                                var config;

                                switch (platform) {
                                    case "I":
                                        config = {
                                            "alert": true,
                                            "badge": true,
                                            "sound": true
                                        };
                                        break;
                                    case "A":
                                        config = {
                                            "senderID": "821213821567"
                                        };
                                        break;
                                }
                                document.addEventListener("deviceready", function () {
                                    $cordovaPush.register(config).then(function (result) {
                                        registerFactory.saveID(result);
                                        localFactory.set("RegisterID", result);
                                    }, function (error) {
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Erro ao registrar-se no servidor de push."
                                        });
                                    });
                                }, false);

                                if (!localFactory.get("Dados.IdEmpresa") && !localFactory.get("Dados.Habilitacao")) {
                                    $scope.go("/selecao");
                                } else if (!localFactory.get("Dados.IdEmpresa") && localFactory.get("Dados.Habilitacao") != "S") {
                                    $scope.go("/mapa");
                                } else {
                                    localFactory.get("Dados.Habilitacao") != "N" ? $scope.go("/comHabilitacao") : $scope.go("/semHabilitacao");
                                }
                            }
                        });
                    }
                }

                $scope.fbLogin = function () {
                    $cordovaOauth.facebook("109980196115110", ["email"]).then(function (response) {
                        $http.get('https://graph.facebook.com/v2.2/me?access_token=' + response.access_token + '&fields=id,name&format=json').then(function (user) {
                            sessionStorage.setItem('fbAccessToken', response.access_token);
                            var data = {
                                idUsuarioFb: user.data.id,
                                accessToken: response.access_token
                            };

                            externalFactory.post("/loginfacebook", data, "options").then(function (retorno) {
                                var data = retorno.data;

                                if (data.register) {
                                    $scope.go("/facebook");
                                } else if (data.error) {
                                    $ionicPopup.alert({
                                        title: "Atenção",
                                        template: data.error
                                    });
                                } else {
                                    console.log(retorno);
                                    angular.forEach(data.DadosUsuario, function (value, key) {
                                        localFactory.set('Dados.' + key, value);
                                    });
                                    localFactory.set("key", data.key);
                                    localFactory.set('Logado', true);
                                    localFactory.set('ServicoSelecionado', retorno.data.ServicoSelecionado);

                                    $ionicLoading.hide();

                                    if (!$scope.isWebDebug()) {
                                        var config;

                                        switch (platform) {
                                            case "I":
                                                config = {
                                                    "alert": true,
                                                    "badge": true,
                                                    "sound": true
                                                };
                                                break;
                                            case "A":
                                                config = {
                                                    "senderID": "821213821567"
                                                };
                                                break;
                                        }

                                        document.addEventListener("deviceready", function () {
                                            $cordovaPush.register(config).then(function (result) {
                                                registerFactory.saveID(result);
                                                localFactory.set("RegisterID", result);
                                            }, function (error) {
                                                $ionicPopup.alert({
                                                    title: "Atenção",
                                                    template: "Erro ao registrar-se no servidor de push."
                                                });
                                            });
                                        }, false);

                                    }

                                    irAposLogin();
                                }
                            }, function (erro) {
                                loginFailed();
                            });

                        }, function (err) {
                            loginFailed();
                        });
                    }, function (error) {
                        loginFailed();
                    });
                };

                function irAposLogin() {
                    if (!localFactory.get("Dados.IdEmpresa") && !localFactory.get("Dados.Habilitacao")) {
                        $scope.go("/selecao");
                    } else if (!localFactory.get("Dados.IdEmpresa") && localFactory.get("Dados.Habilitacao") != "S") {
                        $scope.go("/mapa");
                    } else {
                        localFactory.get("Dados.Habilitacao") != "N" ? $scope.go("/comHabilitacao") : $scope.go("/semHabilitacao");
                    }
                }

                function irCadastro() {
                    $scope.go("/cadastro");
                }

                function irEsqueciSenha() {
                    $scope.go("/senha");
                }
            }]);
