angular.module('iclan.mapaController', ['ngMap'])

        .controller('mapaController', ['$scope', '$filter', '$ionicLoading', '$ionicModal', '$ionicPopup', '$cordovaGeolocation', 'externalFactory', 'localFactory', 'NgMap',
            function ($scope, $filter, $ionicLoading, $ionicModal, $ionicPopup, $cordovaGeolocation, externalFactory, localFactory, NgMap) {

                localFactory.set("Pagina", "mapa");

                /* $scope.$on('mapInitialized', function(event, map) {
                 $scope.map = map;
                 );
                 
                 NgMap.getMap().then(function (map) {
                 $scope.map = map;
                 });*/


                var vm = this;

                NgMap.getMap().then(function (map) {
                    vm.map = map;
                });

                vm.showDetail = function (e, cfc) {
                    vm.cfc = cfc;
                    vm.map.showInfoWindow('foo-iw', cfc.IdEmpresa);
                };

                if (!localFactory.get("Dados.IdEmpresa"))
                    $scope.botaoVoltar = true;
                else
                    $scope.botaoVoltar = false;

                $scope.botaoSolicitar = false;


                $scope.buscaCoordenadas = function (buscar, local) {
                    $ionicLoading.show({
                        template: "Capturando coordenadas ..."
                    });

                    $cordovaGeolocation.getCurrentPosition({timeout: 10000})
                            .then(function (position) {

                                localFactory.set("Dados.Latitude", position.coords.latitude);
                                localFactory.set("Dados.Longitude", position.coords.longitude);
                                //console.log("Latitude:"+position.coords.latitude+" Longitude"+position.coords.longitude);


                                var data = {
                                    Home: [position.coords.latitude, position.coords.longitude],
                                    Coordenadas: [position.coords.latitude, position.coords.longitude],
                                    key: localFactory.get("key"),
                                    Servico: localFactory.get("ServicoSelecionado")
                                };

                                var pos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);

                                // $scope.map.setCenter(pos);
                                NgMap.getMap().then(function (map) {
                                    map.setCenter(pos);
                                });

                                $ionicLoading.hide();

                                if (buscar)
                                    buscarCFCsMapa(data);
                                else
                                    $scope.buscar(local);

                            }, function (erro) {
                                $ionicLoading.hide();

                                var alertPopup = $ionicPopup.alert({
                                    title: "Impossível verificar suas coordenadas. Verifique seu GPS.",
                                    okText: "Já verifiquei meu GPS."
                                });

                                alertPopup.then(function (response) {
                                    $scope.buscaCoordenadas(1, "");
                                });
                            })
                            .catch(function (error) {
                                $scope.buscaCoordenadas(buscar, local);
                            });

                }


                $scope.buscar = function (local) {
                    if (localFactory.get("Dados.Latitude") == null && localFactory.get("Dados.Longitude") == null) {
                        $scope.buscaCoordenadas(0, local);
                    } else {
                        geocoder = new google.maps.Geocoder();
                        geocoder.geocode({'address': local}, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                //$scope.map.setCenter(results[0].geometry.location);
                                NgMap.getMap().then(function (map) {
                                    map.setCenter(results[0].geometry.location);
                                });
                                var home = [localFactory.get("Dados.Latitude"), localFactory.get("Dados.Longitude")];
                                var coords = [];
                                coords.push(results[0].geometry.location.lat());
                                coords.push(results[0].geometry.location.lng());

                                var data = {
                                    Home: home,
                                    Coordenadas: coords,
                                    key: localFactory.get("key"),
                                    Servico: localFactory.get("ServicoSelecionado")
                                };
                                buscarCFCsMapa(data);
                            }
                        });
                    }
                };


                function buscarCFCsMapa(data) {
                    $scope.cfcs = [];

                    $ionicLoading.show({
                        template: 'Buscando CFCs...'
                    });

                    externalFactory.post("/buscar-cfcs-mapa", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                                $ionicLoading.hide();
                            }).success(function (retorno) {
                        console.log(retorno);
                        if (retorno.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: retorno.error
                            });

                        } else {
                            $scope.cfcs = retorno.CFCs;
                        }
                        $ionicLoading.hide();
                    });
                }


                $ionicModal.fromTemplateUrl('templates/modais/horariosInscricao.html', {
                    scope: $scope,
                }).then(function (modal) {
                    $scope.modal = modal
                });

                $scope.showHorarios = function (cfc) {
                    $scope.botaoSolicitar = false;
                    if (cfc.Cadastrado != 'S') {
                        $ionicPopup.alert({
                            title: 'Atenção',
                            template: 'Infelizmente este CFC não está cadastrado no iCLAN.'
                        });
                    } else if (cfc.Servico == '') {
                        $ionicPopup.alert({
                            title: 'Atenção',
                            template: 'Este CFC não possui este serviço.'
                        });
                    } else {
                        $scope.cfc = cfc;
                        var currentDate = new Date();
                        var data = {
                            IdCFC: cfc.IdEmpresa,
                            key: localFactory.get("key"),
                            data: (currentDate.getDate() + 1) + "/" + (currentDate.getMonth() + 1) + "/" + currentDate.getFullYear()
                        };

                        $ionicLoading.show({
                            template: "Buscando horários ..."
                        });

                        externalFactory.post("/buscar-horarios-solicitacoes", data, "options")

                                .error(function (error) {
                                    $ionicPopup.alert({
                                        title: "Atenção",
                                        template: "Não foi possível conectar-se ao servidor."
                                    });
                                    $ionicLoading.hide();
                                }).success(function (retorno) {
                            if (retorno.error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: retorno.error
                                });
                                console.log(retorno);
                                $scope.semRegistro = true;
                            } else {
                                $scope.horarios = retorno.Solicitacoes;
                                $scope.semRegistro = false;
                                console.log("-----------");
                                console.log($scope.horarios);
                            }
                            $ionicLoading.hide();
                        });

                        $scope.modal.show();
                    }
                };

                $scope.validDate = function (data) {
                    if ($filter('date')($scope.onezoneDatepicker.date, "dd/MM/yyyy") == data) {
                        return true;
                    }
                    return false;
                }

                $scope.clickCalendario = function () {
                    $scope.botaoSolicitar = false;
                    $scope.horarios = null;
                    var data = {
                        IdCFC: $scope.cfc.IdEmpresa,
                        key: localFactory.get("key"),
                        data: $filter('date')($scope.onezoneDatepicker.date, "dd/MM/yyyy")
                    };

                    $ionicLoading.show({
                        template: "Buscando horários ..."
                    });

                    externalFactory.post("/buscar-horarios-solicitacoes", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                                $ionicLoading.hide();
                            }).success(function (retorno) {
                        if (retorno.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: retorno.error
                            });
                            console.log(retorno);
                            $scope.semRegistro = true;
                        } else {
                            console.log(retorno);
                            $scope.horarios = retorno.Solicitacoes;
                            $scope.semRegistro = false;

                        }
                        $ionicLoading.hide();
                    });

                    $scope.modal.show();

                };

                $scope.hideHorarios = function () {
                    $scope.horarios = null;
                    $scope.modal.hide();
                };


                var data, horarioInscricao;

                $scope.seleciona = function (horario) {
                    data = {
                        IdPessoa: localFactory.get("Dados.IdPessoa"),
                        IdCFC: $scope.cfc.IdEmpresa,
                        key: localFactory.get("key")
                    };
                    horarioInscricao = {
                        Horarios: [horario],
                        IdPessoa: "",
                        Status: "A"
                    };
                    $scope.botaoSolicitar = true;
                };


                var currentDate = new Date();
                var date = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() + 1);
                $scope.date = date;
                var highlights = [
                    {
                        date: new Date(2016, 04, 14),
                        color: '#8FD4D9',
                        textColor: '#fff'
                    },
                    {
                        date: new Date(2016, 4, 18)
                    },
                    {
                        date: new Date(2016, 4, 19)
                    },
                    {
                        date: new Date(2016, 4, 20)
                    }
                ];
                $scope.onezoneDatepicker = {
                    date: date,
                    mondayFirst: true,
                    months: ["Janeiro", "Fevereiro", "Março", "Abril", "Maio", "Junho", "Julho", "Agosto", "Setembro", "Outubro", "Novembro", "Dezembro"],
                    daysOfTheWeek: ["Dom", "Seg", "Ter", "Qua", "Qui", "Sex", "Sab"],
                    startDate: new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate()),
                    endDate: new Date(2024, 1, 26),
                    disablePastDays: false,
                    disableSwipe: true,
                    disableWeekend: false,
                    showDatepicker: true,
                    showTodayButton: true,
                    calendarMode: true,
                    hideCancelButton: false,
                    hideSetButton: false,
                    disableDaysOfWeek: [0],
                    callback: $scope.clickCalendario

                };

                $scope.showDatepicker = function () {
                    $scope.onezoneDatepicker.showDatepicker = true;

                };

                $scope.voltar = function () {
                    $scope.go("/selecao");
                };

                $scope.solicitar = function () {
                    $ionicLoading.show({
                        template: "Agendando ..."
                    });

                    externalFactory.post("/alterar-cfc", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                            }).success(function (retorno) {
                        if (retorno.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: retorno.error
                            });

                            $ionicLoading.hide();
                        } else {
                            horarioInscricao.key = localFactory.get("key");
                            horarioInscricao.IdCFC = $scope.cfc.IdEmpresa;

                            externalFactory.post("/solicitar-agendamento", horarioInscricao, "options")

                                    .error(function (error) {
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Não foi possível conectar-se ao servidor."
                                        });
                                        $ionicLoading.hide();
                                    }).success(function (retorno) {
                                if (retorno.error) {
                                    $ionicPopup.alert({
                                        title: "Atenção",
                                        template: retorno.error
                                    });
                                } else {
                                    localFactory.set("Dados.IdEmpresa", $scope.cfc.IdEmpresa);
                                    $scope.modal.hide();
                                    $scope.go("/semHabilitacao");
                                }
                                $ionicLoading.hide();
                            });
                        }
                    });
                };

            }]);
