angular.module('iclan.novaCNHController', [])

.controller('novaCNHController', ['$scope', '$ionicLoading', '$ionicPopup', 'externalFactory', 'localFactory',

function($scope, $ionicLoading, $ionicPopup, externalFactory, localFactory) {

	var vm = this;

	// Métodos membro
	vm.init      = init;
	vm.cadastrar = cadastrar;
	vm.exit      = exit;

	//Inicializar
	vm.init ();

	function init(){
		localFactory.set("Pagina", "novaCNH");
		vm.notificacao = true;
	}

	function cadastrar () {

        if (vm.nome && vm.rg && vm.cnh && vm.nascimento) {

			var notificacaoPar = "S"
            if(!vm.notificacao) {
                notificacaoPar = "N";
            }

			var dataNascimento = vm.nascimento.getFullYear ();

			var mesNascimento  = vm.nascimento.getMonth()+1;
			if (mesNascimento < 10) {
				mesNascimento = "0" + mesNascimento;
			}

			dataNascimento += "-"+mesNascimento;

			var diaNascimento  = vm.nascimento.getDate();

			if (diaNascimento < 10) {
				diaNascimento = "0" + diaNascimento;
			}

			dataNascimento += "-"+mesNascimento;

			$ionicLoading.show({
                template: "Cadastrando nova CNH ..."
            });

            var data = {
                key: localFactory.get("key"),
                Nome: vm.nome,
                RG: vm.rg,
                CNH: vm.cnh,
				DataNascimento: dataNascimento,
                Estado: vm.estado,
                Notificacao: notificacaoPar
            };

            externalFactory.post("/cadastrar-carteira", data, "options")

            .error(function(error) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "Não foi possível conectar-se ao servidor."
                });
                $ionicLoading.hide();
            }).success(function(retorno) {
                if(retorno.error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: retorno.error
                    });
                } else {
					vm.exit();
                }
                $ionicLoading.hide();
            });
        }
    };

    function exit () {
        $scope.back();
    };

}]);
