angular.module('iclan.novoCarroController', [])

.controller('novoCarroController', ['$scope', '$ionicLoading', '$ionicPopup', 'externalFactory', 'localFactory',

function($scope, $ionicLoading, $ionicPopup, externalFactory, localFactory) {

	var vm = this;

	//Métodos membro
	vm.init = init;
	vm.cadastrar = cadastrar;
	vm.exit = exit;
	
	//Inicialização
	vm.init ();
	
	//Métodos
	function init () {
		localFactory.set("Pagina", "novoCarro");
		vm.notificacao = true;		
	}
	
    function cadastrar () {

        if(vm.nome && vm.placa && vm.renavam) {
			
			var notificacaoPar = "S"
            if(!vm.notificacao) {
                notificacaoPar = "N";
            }

            $ionicLoading.show({
                template: "Cadastrando novo veículo ..."
            });

            var data = {
                key: localFactory.get("key"),
                Nome: vm.nome,
                Placa: vm.placa,
                Renavam: vm.renavam,
                Estado: vm.estado,
                Notificacao: notificacaoPar
            };

            externalFactory.post("/cadastrar-carro", data, "options")

            .error(function(error) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "Não foi possível conectar-se ao servidor."
                });
                $ionicLoading.hide();
            }).success(function(retorno) {
                if(retorno.error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: retorno.error
                    });
                } else {
                    vm.exit();
                }
                $ionicLoading.hide();
            });
        }
    };

    function exit(){
        $scope.back();
    };

}]);
