angular.module('iclan.perfilController', [])

        .controller('perfilController', function ($ionicLoading, $ionicPopup, $scope, localFactory, externalFactory, backButtonFactory, $filter) {

            var vm = this;

            //Métodos membro
            vm.init = init;
            vm.alterarPerfil = alterarPerfil;
            vm.exit = exit;

            //Inicialização
            vm.init();

            //Funções
            function init() {

                localFactory.set("Pagina", "perfil");
                
                var data = {
                    key: localFactory.get("key"),
                    IdPessoa: localFactory.get("Dados.IdPessoa")
                };

                $ionicLoading.show({
                    template: 'Buscando cadastro ...'
                });

                externalFactory.post("/buscar-perfil", data, "options")

                        .error(function (error) {

                            $ionicLoading.hide();

                            $ionicPopup.alert({
                                title: "Atenção",
                                template: "Não foi possível conectar-se ao servidor."
                            });
                        }).success(function (retorno) {

                    $ionicLoading.hide();

                    if (retorno.error) {
                        $ionicPopup.alert({
                            title: "Atenção",
                            template: retorno.error
                        });
                    } else {
                        if (angular.isUndefined(retorno.DadosUsuario.DataNascimento) || retorno.DadosUsuario.DataNascimento == null) {
                            dt = '';
                        } else {
                            var dt = retorno.DadosUsuario.DataNascimento;
                            dt = new Date(dt);
                        }
                        vm.nome = retorno.DadosUsuario.Nome;
                        vm.email = retorno.DadosUsuario.Email;
                        vm.nascimento = dt;
                        vm.cpf = retorno.DadosUsuario.CPF;
                        vm.rg = retorno.DadosUsuario.Rg;
                        vm.cep = retorno.DadosUsuario.CEP;
                        vm.endereco = retorno.DadosUsuario.Endereco;
                        vm.telefone = retorno.DadosUsuario.Telefone;
                        vm.cidade = retorno.DadosUsuario.Cidade;
                        vm.estado = retorno.DadosUsuario.Estado;
                        vm.mae = retorno.DadosUsuario.Mae;
                        vm.pai = retorno.DadosUsuario.Pai;
                        vm.renach = retorno.DadosUsuario.Renach;
                    }
                });
            }

            function alterarPerfil() {
                if (vm.nome && vm.nascimento &&
                        vm.cpf && vm.cep &&
                        vm.endereco && vm.telefone && vm.cidade) {

                    var dataNascimento = vm.nascimento.getFullYear() + "-" + (vm.nascimento.getMonth() + 1);
                    var diaNascimento = vm.nascimento.getDate();

                    if (diaNascimento < 10) {
                        diaNascimento = "0" + diaNascimento;
                    }

                    dataNascimento += "-" + diaNascimento;

                    var data = {
                        IdPessoa: localFactory.get("Dados.IdPessoa"),
                        key: localFactory.get("key"),
                        Nome: vm.nome,
                        DataNascimento: dataNascimento,
                        CPF: vm.cpf,
                        Rg: vm.rg,
                        CEP: vm.cep,
                        Endereco: vm.endereco,
                        Telefone: vm.telefone,
                        Estado: vm.estado,
                        Cidade: vm.cidade,
                        NomeMae: vm.mae,
                        NomePai: vm.pai
                    };

                    $ionicLoading.show({
                        template: 'Alterando ...'
                    });

                    externalFactory.post("/alterar-dados", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                                $ionicLoading.hide();
                            }).success(function (retorno) {
                        if (retorno.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: retorno.error
                            });

                            $ionicLoading.hide();
                        } else {
                            localFactory.set("Dados.Nome", vm.nome);
                            localFactory.set("Dados.DataNascimento", dataNascimento);
                            localFactory.set("Dados.CPF", vm.cpf);
                            localFactory.set("Dados.Rg", vm.rg);
                            localFactory.set("Dados.CEP", vm.cep);
                            localFactory.set("Dados.Endereco", vm.endereco);
                            localFactory.set("Dados.Telefone", vm.telefone);
                            localFactory.set("Dados.Estado", vm.estado);
                            localFactory.set("Dados.Cidade", vm.cidade);
                            localFactory.set("Dados.Mae", vm.mae);
                            localFactory.set("Dados.Pai", vm.pai);

                            if (localFactory.get("Dados.CPF").trim() == "" || localFactory.get("Dados.CPF") == null) {
                                $scope.botaoCadastro = false;
                            } else {
                                $scope.botaoCadastro = true;
                            }

                            $ionicLoading.hide();

                            $scope.back();
                        }
                    });
                }
            }
            ;

            function exit() {
                $scope.back();
            }

        });
