angular.module('iclan.principalController', ['ngMap'])

.filter('array_slice', function() {
    return function(arr, start, end) {
        if (arr) {
            return arr.slice(start, end);
        }
    };
})

.controller('principalController', ['$scope', '$filter', '$rootScope', '$ionicLoading', '$ionicModal', '$ionicPopup', '$ionicScrollDelegate', 'externalFactory', 'localFactory', 'backButtonFactory', 'NgMap', '$cordovaGeolocation',
    function($scope, $filter, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicScrollDelegate, externalFactory, localFactory, backButtonFactory, NgMap, $cordovaGeolocation) {

        // inicializa variaveis
        $scope.statusClick = 1; //1 - inicial 2-click logo ou item cfc
        $scope.cfcset = null;
        $scope.flag = 0;
        $scope.selectservicos = localFactory.get("select_servicos");
        var servico_selecionado2 = null;
        var categoria2 = null;

        $scope.carregar = function() {
            $scope.statusClick = 1;
            $scope.buscaCoordenadas(1, '');
            NgMap.getMap().then(function(map) {
                map.setZoom(14);
            });
            $ionicScrollDelegate.scrollTop();
        };

        var vm = this;
        NgMap.getMap().then(function(map) {
            vm.map = map;
        });

        vm.showDetail = function(e, cfc, indexArray) {
            vm.cfc = cfc;
            vm.map.showInfoWindow('foo-iw', cfc.IdEmpresa);
            $scope.troca(2, indexArray);
        };

        if (!localFactory.get("Dados.IdEmpresa"))
            $scope.botaoVoltar = true;
        else
            $scope.botaoVoltar = false;

        $scope.botaoSolicitar = false;

        function moveToLocation(lat, lng) {
            var center = new google.maps.LatLng(lat, lng);
            NgMap.getMap().then(function(map) {
                map.panTo(center);
                map.setZoom(16);
            });
        }

        $scope.troca = function(status, idcfc) {
            $scope.cfcset = $scope.cfcs[idcfc];
            moveToLocation($scope.cfcset.latitude, $scope.cfcset.longitude);
            $scope.statusClick = status;
            $ionicScrollDelegate.scrollTop();
            if ($scope.cfcset.Cadastrado == 'S') {
                servicos($scope.cfcset.IdEmpresa);
            }
        };

        $scope.showPopup = function() {
            $scope.data = {};

            // An elaborate, custom popup
            var myPopup = $ionicPopup.show({
                template: '<input type="text" ng-model="data.local">',
                title: 'Informe a cidade desejada',
                subTitle: '',
                scope: $scope,
                buttons: [{
                    text: 'Cancelar'
                }, {
                    text: '<b>Procurar</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        if (!$scope.data.local) {
                            //don't allow the user to close unless he enters wifi password
                            e.preventDefault();
                        } else {
                            return $scope.data.local;
                        }
                    }
                }]
            });

            NgMap.getMap().then(function(map) {
                map.setZoom(14);
            });

            myPopup.then(function(res) {
                if (res) {
                    $scope.buscar(res);
                }
            });

        };

        function frota(idempresa) {
            $scope.frota = [];

            $ionicLoading.show({
                template: 'Buscando Frota...'
            });

            var data = {
                IdCFC: idempresa
            };

            externalFactory.post("/buscar-frota", data, "options")

            .error(function(error) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "Não foi possível conectar-se ao servidor."
                });
                $ionicLoading.hide();
            }).success(function(retorno) {
                console.log(retorno);
                if (retorno.error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: retorno.error
                    });

                } else {
                    $scope.frota = retorno.frota;
                }
                $ionicLoading.hide();
            });
        };

        function instrutores(idempresa) {
            $scope.instrutores = [];

            $ionicLoading.show({
                template: 'Buscando Instrutores...'
            });

            var data = {
                IdCFC: idempresa
            };

            externalFactory.post("/buscar-instrutores", data, "options")

            .error(function(error) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "Não foi possível conectar-se ao servidor."
                });
                $ionicLoading.hide();
            }).success(function(retorno) {
                console.log(retorno);
                if (retorno.error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: retorno.error
                    });

                } else {
                    $scope.instrutores = retorno.instrutores;
                }
                $ionicLoading.hide();
            });
        };

        function servicos(idempresa) {
            $scope.servicos = [];

            var data = {
                IdCFC: idempresa
            };

            $ionicLoading.show({
                template: 'Buscando Serviços...'
            });

            externalFactory.post("/buscar-servicos-cfc", data, "options")

            .error(function(error) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "Não foi possível conectar-se ao servidor."
                });
                $ionicLoading.hide();
            }).success(function(retorno) {
                console.log(retorno);
                if (retorno.error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: retorno.error
                    });

                } else {
                    $scope.servicos = retorno.servicos;
                }
                $ionicLoading.hide();
            });
        };

        $scope.buscar = function(local) {
            $scope.statusClick = 1;
            if (localFactory.get("Dados.Latitude") == null && localFactory.get("Dados.Longitude") == null) {
                $scope.buscaCoordenadas(0, local);
            } else {
                geocoder = new google.maps.Geocoder();
                geocoder.geocode({
                    'address': local
                }, function(results, status) {
                    if (status == google.maps.GeocoderStatus.OK) {
                        //$scope.map.setCenter(results[0].geometry.location);
                        NgMap.getMap().then(function(map) {
                            map.setCenter(results[0].geometry.location);
                        });
                        var home = [localFactory.get("Dados.Latitude"), localFactory.get("Dados.Longitude")];
                        var coords = [];
                        coords.push(results[0].geometry.location.lat());
                        coords.push(results[0].geometry.location.lng());

                        var data = {
                            Home: home,
                            Coordenadas: coords,
                            key: localFactory.get("key"),
                            Servico: localFactory.get("select_servicos")
                        };
                        buscarCFCsMapa(data);
                    }
                });
            }
        };

        $scope.buscaCoordenadas = function(buscar, local) {
            if ($scope.flag == 0) {
                $ionicLoading.show({
                    template: "Capturando coordenadas ..."
                });
            }
            var posOptions = {
                timeout: 10000,
                enableHighAccuracy: false
            };
            $cordovaGeolocation.getCurrentPosition(posOptions)
                .then(function(position) {

                    localFactory.set("Dados.Latitude", position.coords.latitude);
                    localFactory.set("Dados.Longitude", position.coords.longitude);
                    console.log("Latitude:" + position.coords.latitude + " Longitude" + position.coords.longitude);


                    var data = {
                        Home: [position.coords.latitude, position.coords.longitude],
                        Coordenadas: [position.coords.latitude, position.coords.longitude],
                        key: localFactory.get("key"),
                        Servico: localFactory.get("select_servicos")
                    };

                    var pos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);

                    NgMap.getMap().then(function(map) {
                        map.setCenter(pos);
                    });

                    $ionicLoading.hide();

                    if (buscar)
                        buscarCFCsMapa(data);
                    else
                        $scope.buscar(local);

                }, function(erro) {
                    $ionicLoading.hide();
                    if ($scope.flag == 0) {
                        var alertPopup = $ionicPopup.alert({
                            title: "Impossível verificar suas coordenadas. Verifique seu GPS.",
                            okText: "Já verifiquei meu GPS."
                        });
                        alertPopup.then(function(response) {
                            $scope.buscaCoordenadas(1, "");
                        });
                        $scope.flag = 1;
                    } else {
                        $scope.showPopup();
                    }
                })
                .catch(function(error) {
                    $scope.buscaCoordenadas(null, local);
                });

        };

        function buscarCFCsMapa(data) {
            $scope.cfcs = [];

            $ionicLoading.show({
                template: 'Buscando CFCs...'
            });

            externalFactory.post("/buscar-cfcs-mapa", data, "options")

            .error(function(error) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "Não foi possível conectar-se ao servidor."
                });
                $ionicLoading.hide();
            }).success(function(retorno) {
                console.log(retorno);
                if (retorno.error) {
                    $ionicPopup.alert({
                        title: "Atenção",
                        template: retorno.error
                    });
                    localFactory.set("select_servicos", "null");
                } else {
                    //se é diferente de null remover os itens que não faz parte da busca
                    /*var auxArray = retorno.CFCs;
                    if (localFactory.get("select_servicos")) {
                        for (var i = retorno.CFCs.length - 1; i--;) {
                            if (!retorno.CFCs[i].Servico) {
                                retorno.CFCs.splice(i, 1);
                            }
                        }
                    }*/
                    $scope.cfcs = retorno.CFCs;
                }
                $ionicLoading.hide();
                localFactory.set("select_servicos", null);
            });

        };

        $scope.seleciona = function(servico_selecionado, categoria, item) {
            $scope.itemSelecionado = item;
            servico_selecionado2 = servico_selecionado;
            categoria2 = categoria;
            $scope.showServico();
        };
        //TODO: -validar se esta cadastro senao redirecionada para cadastrar.
        $scope.solicitarServico = function() {

            var logado = localFactory.get('Logado');

            if (!logado) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "É necessário possuir cadastro."
                }).then(function() {
                    $scope.go("/tabperfil");
                    $scope.hideServico();
                });
                $ionicLoading.hide()
            } else {

                $ionicLoading.show({
                    template: 'Entrando ...'
                });

                var data = {
                    key: localFactory.get("key"),
                    servico: servico_selecionado2,
                    categoria_carteira: categoria2
                }

                externalFactory.post("/trocar-situacao-habilitado", data, "options")
                    .then(
                        function(retorno) {
                            if (retorno.data.error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: retorno.data.error
                                });
                            } else {
                                localFactory.set("Dados.IdEmpresa",$scope.cfcset.IdEmpresa);
                                localFactory.set("ServicoSelecionado", servico_selecionado2);
                                localFactory.set("Dados.Categoria", categoria2);
                                localFactory.set("Dados.Habilitacao", "N");
                                $scope.go("/semHabilitacao");
                            }
                            $scope.hideServico();
                            $ionicLoading.hide();
                        },
                        function(error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: "Não foi possível conectar-se ao servidor."
                            });
                            $ionicLoading.hide();
                        }
                    )
            }
        }

        //modais

        $ionicModal.fromTemplateUrl('templates/modais/frota.html', {
            scope: $scope,
        }).then(function(modal) {
            $scope.modalFrota = modal
        });

        $scope.showModalFrota = function() {
            frota($scope.cfcset.IdEmpresa);
            $scope.modalFrota.show();
        };
        $scope.hideModalFrota = function() {
            $scope.modalFrota.hide();
        };

        $ionicModal.fromTemplateUrl('templates/modais/instrutores.html', {
            scope: $scope,
        }).then(function(modal) {
            $scope.modalInstrutores = modal
        });

        $scope.showModalInstrutores = function() {
            instrutores($scope.cfcset.IdEmpresa);
            $scope.modalInstrutores.show();
        };
        $scope.hideModalInstrutores = function() {
            $scope.modalInstrutores.hide();
        };

        $ionicModal.fromTemplateUrl('templates/modais/servico.html', {
            scope: $scope,
        }).then(function(modal) {
            $scope.modalServico = modal
        });

        $scope.showServico = function() {
            $ionicScrollDelegate.$getByHandle('modalServico').scrollTop(true);
            $scope.modalServico.show();
        }

        $scope.hideServico = function() {
            $scope.modalServico.hide();
        };
        //fim modais

        // rotas
        $scope.tabprincipal = function() {
            $scope.go("/principal");
        };
        $scope.tabperfil = function() {
            $scope.go("/tabperfil");
        };
        $scope.tabtimeline = function() {
            $scope.go("/semHabilitacao");
        };
        $scope.tabmenu = function() {
            $scope.go("/tabmenu");
        };
        // fim rotas
    }
]);
