angular.module('iclan.selecaoController', [])

.controller('selecaoController', ['$scope', '$rootScope', '$ionicPopup', '$ionicLoading', 'localFactory', 'externalFactory', '$ionicModal',
    function($scope, $rootScope, $ionicPopup, $ionicLoading, localFactory, externalFactory, $ionicModal) {

        var vm = this;
        var action2, servico_selecionado2, categoria2;
        $scope.itemSelecionado;

        localFactory.set("Pagina", "selecao");

        $ionicModal.fromTemplateUrl('templates/modais/servico.html', {
            scope: $scope,
        }).then(function(modal) {
            $scope.modal = modal
        });

        $scope.showHorarios = function() {
            $scope.modal.show();
        }

        $scope.hideHorarios = function() {
            $scope.modal.hide();
        };

        $scope.seleciona = function(action, servico_selecionado, categoria, item) {
            $scope.itemSelecionado = item;
            action2 = action;
            servico_selecionado2 = servico_selecionado;
            categoria2 = categoria;
            if (action == 1) {
                if (servico_selecionado == 9) {
                    localFactory.set("Tab", 1);
                }
                if (servico_selecionado == 10) {
                    localFactory.set("Tab", 2);
                }
                $scope.go("/comHabilitacao");
            } else {
                $scope.showHorarios();
            }
        };

        $scope.set = function() {

            $ionicLoading.show({
                template: 'Entrando ...'
            });

            var data = {
                key: localFactory.get("key"),
                habilitado: (action2 == 0 ? false : true),
                servico: servico_selecionado2,
                categoria_carteira: categoria2
            }

            externalFactory.post("/trocar-situacao-habilitado", data, "options")
                .then(
                    function(retorno) {
                        if (retorno.data.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: retorno.data.error
                            });
                        } else {
                            if (action2 == 0) {
                                localFactory.set("ServicoSelecionado", servico_selecionado2);
                                localFactory.set("Dados.Categoria", categoria2);
                                localFactory.set("Dados.Habilitacao", "N");
                                $scope.go("/mapa");
                            } else {
                                localFactory.set("Dados.Habilitacao", "S");
                                $scope.go("/comHabilitacao");
                            }
                        }
                        $scope.hideHorarios();
                        $ionicLoading.hide();
                    },
                    function(error) {
                        $ionicPopup.alert({
                            title: "Atenção",
                            template: "Não foi possível conectar-se ao servidor."
                        });
                        $ionicLoading.hide();
                    }
                )
        }

        $scope.carregar = function() {
            vm.servicos = "";
            $ionicLoading.show({
                template: 'Carregando...'
            });

            var data = {
                IdCFC: localFactory.get("Dados.IdEmpresa"),
                key: localFactory.get("key")
            };

            externalFactory.post("/buscar-servicos", data, "options")

            .error(function(error) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "Não foi possível conectar-se ao servidor."
                });
                $ionicLoading.hide();
            }).success(function(retorno) {
                console.log(retorno);
                if (!retorno.error) {
                    vm.servicos = retorno.Servicos;
                }

                $ionicLoading.hide();

            });

        }

    }
]);
