angular.module('iclan.simuladorController', [])

        .filter('buscaData', function () {
            return function (input, dia, mes, ano) {
                var output = [];
                dia = ("0" + (dia)).slice(-2);
                angular.forEach(input, function (value, key) {
                    if (key == dia + '/' + mes + '/' + ano) {
                        angular.forEach(value, function (value, key) {
                            output.push(value);
                        });
                    }
                });
                return output;
            };
        })

        .controller('simuladorController', ['$scope', '$rootScope', '$ionicLoading', '$ionicPopup', 'externalFactory', '$ionicModal', 'localFactory', '$filter',
            function ($scope, $rootScope, $ionicLoading, $ionicPopup, externalFactory, $ionicModal, localFactory, $filter) {

                var day_of_week = new Array('Dom', 'Seg', 'Ter', 'Qua', 'Qui', 'Sex', 'Sab');
                $scope.month_of_year = new Array('Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro');

                var Calendar = new Date();

                var year = Calendar.getFullYear();       // Retorna o ano
                var month = Calendar.getMonth();    // Retorna mes (0-11)
                var today = Calendar.getDate();     // Retorna dias (1-31)
                var weekday = Calendar.getDay();   // Retorna dias (1-31)
                var DAYS_OF_WEEK = 7;    // "constant" para o numero de dias na semana
                var DAYS_OF_MONTH = 31;    // "constant" para o numero de dias no mes

                Calendar.setDate(1);    // Comecar o calendario no dia '1'
                Calendar.setMonth(month);    // Comecar o calendario com o mes atual

                $scope.meses = [];
                $scope.semana = [];
                $scope.ano = year;
                $scope.mesAtual = ("0" + (month + 1)).slice(-2);
                $scope.mesAtualNum = month;
                $scope.mesInicial = month;
                $scope.diaAtual = today;
                $scope.diaSelecionado = '';

                $scope.hrs = [];

                var vm = this;

                //Métodos membro
                vm.carregaAgenda = carregaAgenda;

                $scope.armazenaSelect = function (tipo) {
                    if (vm.veiculoSelected && tipo == 1) {
                        localFactory.set("select_veiculo", vm.veiculoSelected);
                    }
                    if (vm.instrutorSelected && tipo == 2) {
                        localFactory.set("select_instrutor", vm.instrutorSelected);
                    }
                }

                $scope.carregar = function () {
                    buildMonth();
                }

                $scope.buscainstrutor = function () {

                    if (vm.veiculoSelected) {

                        var data = {
                            IdCFC: localFactory.get("Dados.IdEmpresa"),
                            key: localFactory.get("key")
                        };

                        $ionicLoading.show({
                            template: "Buscando..."
                        });

                        externalFactory.post("/busca-instrutor", data, "options")

                                .error(function (error) {
                                    $ionicPopup.alert({
                                        title: "Atenção",
                                        template: "Não foi possível conectar-se ao servidor."
                                    });
                                    $ionicLoading.hide();
                                }).success(function (retorno) {
                            if (retorno.error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: retorno.error
                                });
                                console.log(retorno);
                                $scope.semRegistro = true;
                            } else {
                                console.log(retorno);
                                $scope.instrutores = retorno.instrutores;

                            }
                            $ionicLoading.hide();
                        });
                    }
                }

                function carregaAgenda() {
                    $scope.fechaSelecao();
                    buildMonth();
                }

                function buildMonth() {
                    $scope.meses = [];
                    $scope.semana = [];
                    for (index = 0; index < Calendar.getDay(); index++) {
                        $scope.semana.push("");
                    }

                    for (index = 0; index < DAYS_OF_MONTH; index++)
                    {
                        if (Calendar.getDate() > index)
                        {
                            week_day = Calendar.getDay();
                            if (week_day == 0) {

                            }
                            if (week_day != DAYS_OF_WEEK)
                            {
                                var day = Calendar.getDate();
                                // if (today == Calendar.getDate()) {
                                //cal += highlight_start + day + highlight_end + TD_end;
                                // } else {
                                $scope.semana.push(String(day));
                                // }
                            }
                            if (week_day == DAYS_OF_WEEK - 1) {
                                $scope.meses.push($scope.semana);
                                $scope.semana = [];
                            }
                        }
                        Calendar.setDate(Calendar.getDate() + 1);
                        //$scope.mes.push($scope.semana);
                    }
                    if ($scope.semana) {
                        $scope.meses.push($scope.semana);
                        $scope.semana = [];
                    }
                    console.log($scope.meses);
                    getEvent();
                }


                $scope.buscaveiculos = function () {
                    var data = {
                        categoria: localFactory.get("Dados.CategoriaCarteira"),
                        IdCFC: localFactory.get("Dados.IdEmpresa"),
                        key: localFactory.get("key")
                    };

                    $ionicLoading.show({
                        template: "Buscando..."
                    });

                    externalFactory.post("/busca-veiculos", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                                $ionicLoading.hide();
                            }).success(function (retorno) {
                        if (retorno.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: retorno.error
                            });
                            console.log(retorno);
                            $scope.semRegistro = true;
                        } else {
                            console.log(retorno);
                            $scope.veiculos = retorno.veiculos;

                        }
                        $ionicLoading.hide();
                    });
                }

                function getEvent() {

                    $scope.solicitacoes = "";

                    $ionicLoading.show({
                        template: 'Carregando horários ...'
                    });

                    var data = {
                        IdCFC: localFactory.get("Dados.IdEmpresa"),
                        key: localFactory.get("key")
                    };

                    externalFactory.post("/buscar-eventos-agenda-teorico", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                                $ionicLoading.hide();
                            }).success(function (retorno) {
                        //console.log(retorno);
                        if (!retorno.error) {
                            $scope.solicitacoes = retorno.Solicitacoes;
                            $scope.hrs = [];
                            //console.log($scope.solicitacoes);
                        }

                        $ionicLoading.hide();

                    });
                }

                $scope.anterior = function () {
                    month = month - 1;
                    Calendar.setMonth(month);
                    Calendar.setDate(1);
                    $scope.mesAtual = ("0" + (month + 1)).slice(-2);
                    $scope.ano = Calendar.getFullYear();
                    buildMonth();
                    $scope.mesAtualNum = month;
                }

                $scope.proximo = function () {
                    month = month + 1;
                    if (month > 11) {
                        month = 0;
                    }
                    Calendar.setMonth(month);
                    Calendar.setDate(1);
                    $scope.mesAtual = ("0" + (month + 1)).slice(-2);
                    $scope.ano = Calendar.getFullYear();
                    buildMonth();
                    $scope.mesAtualNum = month;
                }

                $scope.fechaSelecao = function () {
                    $scope.modal.hide();
                }

                $ionicModal.fromTemplateUrl('templates/modais/marcapratico.html', {
                    scope: $scope,
                }).then(function (modal) {
                    $scope.modal2 = modal
                });

                $scope.showHorarios = function (item) {
                    $scope.diaSelecionado = item;
                    $scope.modal2.show();
                }

                $scope.hideHorarios = function () {
                    $scope.horarios = null;
                    $scope.modal2.hide();
                };

                var data, horarioInscricao;

                $scope.seleciona = function (horario) {
                    data = {
                        IdPessoa: localFactory.get("Dados.IdPessoa"),
                        IdCFC: $scope.cfc.IdEmpresa,
                        key: localFactory.get("key")
                    };
                    horarioInscricao = {
                        Horarios: [horario],
                        IdPessoa: "",
                        Status: "A"
                    };
                    $scope.botaoSolicitar = true;
                };

                $scope.ni_toggle = Array();


                $scope.solicitar = function () {

                    if ($scope.horariosFinal.length) {


                        $ionicLoading.show({
                            template: "Agendando ..."
                        });

                        var data = {
                            IdCFC: localFactory.get("Dados.IdEmpresa"),
                            key: localFactory.get("key"),
                            Horarios: $scope.horariosFinal,
                            Status: "A"
                        };

                        externalFactory.post("/solicitar-agendamento-aula-teorica", data, "options")

                                .error(function (error) {
                                    $ionicPopup.alert({
                                        title: "Atenção",
                                        template: "Não foi possível conectar-se ao servidor."
                                    });
                                    $ionicLoading.hide();
                                }).success(function (retorno) {
                            console.log(retorno);
                            if (retorno.error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: retorno.error
                                });
                            } else {
                                $scope.modal2.hide();
                                $scope.hrs.splice(0, $scope.hrs.length);
                                $scope.go("/semHabilitacao");
                            }
                            $ionicLoading.hide();
                        });
                    }

                };


                $scope.buscaList = [
                    {text: "Manhã", checked: false},
                    {text: "Tarde", checked: false},
                    {text: "Noite", checked: false}
                ];

                $scope.dataagora = {
                    value: new Date()
                };

                $scope.setItemSelect = function (item) {
                    $scope.horariosFinal = [];
                    var data = {
                        IdEmpresa: localFactory.get("Dados.IdEmpresa"),
                        key: localFactory.get("key"),
                        StatusAtendidos: 1
                    };

                    externalFactory.post("/buscar-solicitacoes-pessoa", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                            }).success(function (retorno) {
                        if (retorno.Solicitacoes) {
                            $scope.horarios_aux = retorno.Solicitacoes['Aula Prática'];
                            angular.forEach($scope.horarios_aux, function (value, key) {
                                $scope.horariosFinal.push(value);
                            });
                        }
                    });


                    if ($scope.ni_toggle[item.IdAgenda]) {
                        $scope.horarios_aux = $filter('buscaData')($scope.solicitacoes, $scope.diaSelecionado, $scope.mesAtual, $scope.ano);
                        angular.forEach($scope.horarios_aux, function (value, key) {
                            if ($scope.ni_toggle[value.IdAgenda]) {
                                $scope.horariosFinal.push(value);
                            }
                        });
                        $scope.hrs = $scope.horariosFinal;
                        console.log($scope.hrs);
                        $scope.changeAulasPraticas(item);
                    }


                };

                $scope.changeAulasPraticas = function (dia) {
                    var data = {
                        IdEmpresa: localFactory.get("Dados.IdEmpresa"),
                        key: localFactory.get("key"),
                        StatusAtendidos: 1
                    };
                    externalFactory.post("/buscar-regras-cfc", data, "options")

                            .error(function (error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Não foi possível conectar-se ao servidor."
                                });
                            }).success(function (retorno) {
                        if (retorno.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: retorno.error
                            });
                            return false;
                        } else {

                            var diasHorarioIgualSemana = retorno.Regras.Regra1;
                            var diasHorarioUnico = retorno.Regras.Regra2;
                            var diasNoite = retorno.Regras.Regra3;
                            var diasRepetidos = 0;
                            var horasSemanaRepetidas = diasHorarioIgualSemana;
                            var horariosDia = [];

                            $scope.hrs.sort(function (a, b) {
                                var aux = a["DataInicio"].split("/");
                                var a1 = parseInt(aux[2] + aux[1] + aux[0]);
                                var aux = b["DataInicio"].split("/");
                                var b1 = parseInt(aux[2] + aux[1] + aux[0]);
                                return a1 - b1;
                            });

                            angular.forEach($scope.hrs, function (value, key) {

                                var isInvalid = false;
                                var error = true;

                                var array_dia = dia.DataInicio.split("/");
                                var dataInicio = array_dia[2] + "-" + array_dia[1] + "-" + array_dia[0];


                                // Avalia se dia escolhido está na semana corrente
                                if (dataInicio >= value.PrimeiroDiaSemana
                                        &&
                                        dataInicio <= value.UltimoDiaSemana)
                                {
                                    // Avalia se o horario do dia corrente é igual ao dos dias anteriores
                                    if (dia.HoraInicio == value.HoraInicio && horasSemanaRepetidas > 0) {
                                        horasSemanaRepetidas--;
                                    } else if (dia.HoraInicio == value.HoraInicio && horasSemanaRepetidas <= 0) {
                                        isInvalid = true;
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Não é possível marcar mais de " + retorno.Regras.Regra1 + " horários iguais na mesma semana."
                                        });
                                        $scope.ni_toggle[dia.IdAgenda] = false;
                                    }
                                } else {
                                    horasSemanaRepetidas = diasHorarioIgualSemana;
                                }

                                // Avalia regras de marcação em um dia
                                if (value.DataInicio == dia.DataInicio) {
                                    horariosDia.push(value);
                                    if (horariosDia.length >= 3) {
                                        horariosDia.sort(function (a, b) {
                                            var aux = a["HoraInicio"].split(":");
                                            var a1 = parseInt(aux[0] + aux[1]);
                                            var aux = b["HoraInicio"].split(":");
                                            var b1 = parseInt(aux[0] + aux[1]);
                                            return a1 - b1;
                                        });

                                        var primeiroHorario = parseInt(horariosDia[0].HoraFinal.replace(":", ""));
                                        var segundoHorarioInicio = parseInt(horariosDia[1].HoraInicio.replace(":", ""));
                                        var segundoHorarioFinal = parseInt(horariosDia[1].HoraFinal.replace(":", ""));
                                        var terceiroHorario = parseInt(horariosDia[2].HoraInicio.replace(":", ""));
                                        var diferencaPrimSeg = segundoHorarioInicio - primeiroHorario;
                                        var diferencaSegTerc = terceiroHorario - segundoHorarioFinal;
                                    }
                                    // Avalia se já existem 3 horários no mesmo dia
                                    if (diasRepetidos >= 3) {
                                        isInvalid = true;
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "É permitido somente 3 aulas por dia."
                                        });
                                        $scope.ni_toggle[dia.IdAgenda] = false;
                                    }
                                    // Avalia se existe um intervalo entre a aula 2 e 3
                                    else if (diasRepetidos >= 2 && diferencaPrimSeg <= 50 && diferencaSegTerc <= 50) {
                                        isInvalid = true;
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Deve haver um intervalo de 1h entre a 2ª e a 3ª aula."
                                        });
                                        $scope.ni_toggle[dia.IdAgenda] = false;
                                    }
                                    // Avalia se já foram marcados todos os dias com apenas uma aula (Regra 2)
                                    else if (diasHorarioUnico > 0 && diasRepetidos > 0) {
                                        isInvalid = true;
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Não é permitido marcar mais de um horário neste dia."
                                        });
                                        $scope.ni_toggle[dia.IdAgenda] = false;
                                    } else {
                                        diasRepetidos++;
                                    }
                                } else {
                                    if (diasHorarioUnico > 0) {
                                        diasHorarioUnico--;
                                    }
                                    horariosDia = [];
                                }
                                if (isInvalid == true) {
                                    $scope.hrs[key] = [];
                                    $scope.hrs.splice(key, 1);
                                }
                                if (parseInt(value.HoraInicio.substring(0, 2)) > 17)
                                    diasNoite--;
                            });

                            if (diasNoite != 0) {
                                // Avalia se existe a quantidade mínima de aulas após às 17:00 (Regra 3)
                                if ($scope.hrs.length == 21 - diasNoite) {
                                    $scope.hrs[20 - diasNoite] = [];
                                    $scope.hrs.splice(20 - diasNoite, 1);
                                    $ionicPopup.alert({
                                        title: "Atenção",
                                        template: "Você deve ter no mínimo " + retorno.Regras.Regra3 + " aulas a noite."
                                    });
                                }
                            }
                            // Avalia se já foram marcadas as 20 aulas
                            if ($scope.hrs.length >= 20) {
                                $scope.hrs[20] = [];
                                $scope.hrs.splice(20, 1);
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Você pode marcar até 20 aulas práticas por vez."
                                });
                            }
                        }
                    });
                }

                $scope.timeline = function () {
                    $scope.go("/semHabilitacao");
                }
            }]);
