angular.module('iclan.tabmenuController', ['ngMap'])

.filter('array_slice', function() {
    return function(arr, start, end) {
        if (arr) {
            return arr.slice(start, end);
        }
    };
})

.controller('tabmenuController', ['$scope', '$filter', '$rootScope', '$ionicLoading', '$ionicModal', '$ionicPopup', '$ionicScrollDelegate', 'externalFactory', 'localFactory', 'backButtonFactory', '$location',

    function($scope, $filter, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicScrollDelegate, externalFactory, localFactory, backButtonFactory, $location) {
        //inicializa
        var vm = this;

        $scope.embreve = function() {
            $ionicPopup.alert({
                title: "Atenção",
                template: "Função disponível em breve."
            });
            $ionicLoading.hide();
        }

        $scope.armazenaSelect = function() {
            localFactory.set("select_servicos", vm.servicos);
        }

        $scope.modalPrimeirahabilitacao = function() {
            $ionicModal.fromTemplateUrl('templates/modais/sel1habilitacao.html', {
                scope: $scope,
            }).then(function(modal) {
                $scope.modal = modal
                $scope.modal.show();
            });
        }

        $scope.modalAdicaoCategoria = function() {
            $ionicModal.fromTemplateUrl('templates/modais/seladicaocat.html', {
                scope: $scope,
            }).then(function(modal) {
                $scope.modal = modal
                $scope.modal.show();
            });
        }

        $scope.modalMudancaCategoria = function() {
            $ionicModal.fromTemplateUrl('templates/modais/selmudancacat.html', {
                scope: $scope,
            }).then(function(modal) {
                $scope.modal = modal
                $scope.modal.show();
            });
        }

        $scope.cfcs = function() {
            localFactory.set("select_servicos", null);
            $scope.go('/princial');
            location.reload();
        }

        $scope.fechaSelecao = function() {
            $scope.modal.hide();
        }

        $scope.confirmar = function() {
            $scope.go('/princial');
            $scope.fechaSelecao();
            location.reload();
        }


        // rotas
        $scope.tabprincipal = function() {
            $scope.go("/principal");
        };
        $scope.tabperfil = function() {
            $scope.go("/tabperfil");
        };
        $scope.tabtimeline = function() {
            $scope.go("/semHabilitacao");
        };
        $scope.goto = function(path,item) {
            localFactory.set("Tab", item);
            var logado = localFactory.get('Logado');
            if (!logado) {
                $ionicPopup.alert({
                    title: "Atenção",
                    template: "É necessário possuir cadastro."
                }).then(function() {
                    $scope.go("/tabperfil");
                });
            } else {
                $scope.go(path);
            }
        };
        // fim rotas
    }
]);
