angular.module('iclan.tabperfilController', ['ngCordovaOauth'])

.filter('array_slice', function() {
    return function(arr, start, end) {
        if (arr) {
            return arr.slice(start, end);
        }
    };
})

.controller('tabperfilController', ['$scope', '$filter', '$rootScope', '$ionicLoading', '$ionicModal', '$ionicPopup', '$ionicScrollDelegate', 'externalFactory', 'localFactory', 'backButtonFactory', '$cordovaOauth', 'platform','$timeout','$http','$cordovaPush','registerFactory',

    function($scope, $filter, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicScrollDelegate, externalFactory, localFactory, backButtonFactory, $cordovaOauth, platform,$timeout,$http,$cordovaPush,registerFactory) {

        var vm = this;

        // Variáveis membro do controller
        vm.disable = false;

        // Métodos
        vm.logar = logar;
        vm.irCadastro = irCadastro;
        vm.irEsqueciSenha = irEsqueciSenha;

        // Inicialização
        $scope.logado = localFactory.get('Logado');

        if (localFactory.get("Dados.Email")) {
            vm.email = localFactory.get("Dados.Email");
        }

        function loginFailed() {
            $ionicPopup.alert({
                title: "Atenção",
                template: 'Login via facebook falhou.'
            });
            $timeout(function() {
                $scope.go("/tabperfil");
            }, 1500);

        }

        function logar() {

            if (vm.email && vm.senha) {

                vm.disable = true;

                var data = {
                    Email: vm.email,
                    Senha: vm.senha
                };

                $ionicLoading.show({
                    template: 'Entrando ...'
                });

                externalFactory.post("/login", data, "options")

                .error(function(error) {

                    $ionicPopup.alert({
                        title: "Atenção",
                        template: "Não foi possível conectar-se ao servidor."
                    });
                    $ionicLoading.hide();

                }).success(function(retorno) {
                    if (retorno.Mensagem != "OK") {
                        $ionicPopup.alert({
                            title: "Atenção",
                            template: retorno.Mensagem
                        });
                        $ionicLoading.hide();

                    } else {
                        angular.forEach(retorno.DadosUsuario, function(value, key) {
                            localFactory.set('Dados.' + key, value);
                        });
                        localFactory.set("troca", retorno.troca);
                        localFactory.set("key", retorno.key);
                        localFactory.set('Logado', true);
                        localFactory.set('ServicoSelecionado', retorno.ServicoSelecionado);
                        $ionicLoading.hide();

                        var config;

                        switch (platform) {
                            case "I":
                                config = {
                                    "alert": true,
                                    "badge": true,
                                    "sound": true
                                };
                                break;
                            case "A":
                                config = {
                                    "senderID": "821213821567"
                                };
                                break;
                        }
                        document.addEventListener("deviceready", function() {
                            $cordovaPush.register(config).then(function(result) {
                                registerFactory.saveID(result);
                                localFactory.set("RegisterID", result);
                            }, function(error) {
                                $ionicPopup.alert({
                                    title: "Atenção",
                                    template: "Erro ao registrar-se no servidor de push."
                                });
                            });
                        }, false);

                        if (localFactory.get("Dados.IdEmpresa") && localFactory.get("Dados.Habilitacao")) {
                            $scope.go("/semHabilitacao");
                        }
                    }
                });
            }
        }

        $scope.fbLogin = function() {
            //localFactory.clear(); //limpar antes de logar no facebook
            $cordovaOauth.facebook("109980196115110", ["email"]).then(function(response) {
                $http.get('https://graph.facebook.com/v2.2/me?access_token=' + response.access_token + '&fields=id,name&format=json').then(function(user) {
                    sessionStorage.setItem('fbAccessToken', response.access_token);
                    var data = {
                        idUsuarioFb: user.data.id,
                        accessToken: response.access_token
                    };

                    externalFactory.post("/loginfacebook", data, "options").then(function(retorno) {
                        var data = retorno.data;

                        if (data.register) {
                            $scope.go("/facebook");
                        } else if (data.error) {
                            $ionicPopup.alert({
                                title: "Atenção",
                                template: data.error
                            });
                            console.log("Retorno dos dados");
                        } else {
                            console.log(retorno);
                            angular.forEach(data.DadosUsuario, function(value, key) {
                                localFactory.set('Dados.' + key, value);
                            });
                            localFactory.set("key", data.key);
                            localFactory.set('Logado', true);
                            localFactory.set('ServicoSelecionado', retorno.data.ServicoSelecionado);

                            $ionicLoading.hide();

                            if (!$scope.isWebDebug()) {
                                var config;

                                switch (platform) {
                                    case "I":
                                        config = {
                                            "alert": true,
                                            "badge": true,
                                            "sound": true
                                        };
                                        break;
                                    case "A":
                                        config = {
                                            "senderID": "821213821567"
                                        };
                                        break;
                                }

                                document.addEventListener("deviceready", function() {
                                    $cordovaPush.register(config).then(function(result) {
                                        registerFactory.saveID(result);
                                        localFactory.set("RegisterID", result);
                                    }, function(error) {
                                        $ionicPopup.alert({
                                            title: "Atenção",
                                            template: "Erro ao registrar-se no servidor de push."
                                        });
                                    });
                                }, false);

                            }

                            irAposLogin();
                        }
                    }, function(erro) {
                        loginFailed();
                    });

                }, function(err) {
                    loginFailed();
                });
            }, function(error) {
                loginFailed();
            });
        };

        function irAposLogin() {
            if (localFactory.get("ServicoSelecionado")) {
                $scope.go("/semHabilitacao");
            } else{
                $scope.go("/principal");
            }
        }

        function irCadastro() {
            $scope.go("/cadastro");
        }

        function irEsqueciSenha() {
            $scope.go("/senha");
        }

        $scope.logout = function() {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Você tem certeza que deseja fazer logout?',
                cancelText: 'Cancelar',
                okText: 'Sim'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    localFactory.clear();
                    //$scope.hideModal(0);
                    $scope.go('/tabperfil');
                }
            });
        }

        // rotas
        $scope.tabprincipal = function() {
            $scope.go("/principal");
        };
        $scope.tabperfil = function() {
            $scope.go("/tabperfil");
        };
        $scope.tabtimeline = function() {
            $scope.go("/semHabilitacao");
        };
        $scope.tabmenu = function() {
            $scope.go("/tabmenu");
        };
        $scope.perfil = function() {
            $scope.go("/perfil");
        };
        $scope.exit = function(){
            $scope.back();
        };
        // fim rotas
    }
]);
