angular.module('iclan.directives', [])

.directive('validateEmail', function() {
  var EMAIL_REGEXP = /^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,8})$/;

  return {
	  require: 'ngModel',
	  restrict: 'A',
	  link: function(scope, elm, attrs, ctrl) {
		  // only apply the validator if ngModel is present and Angular has added the email validator
		  if (ctrl && ctrl.$validators.email) {

			  // this will overwrite the default Angular email validator
			  ctrl.$validators.email = function(modelValue) {
				  return ctrl.$isEmpty(modelValue) || EMAIL_REGEXP.test(modelValue);
			  };
		  }
	  }
  };
})
.directive('compareTo', function() {
    return {
        require: "ngModel",
        scope: {
            otherModelValue: "=compareTo"
        },
        link: function(scope, element, attributes, ngModel) {

            ngModel.$validators.compareTo = function(modelValue) {
                return modelValue == scope.otherModelValue;
            };

            scope.$watch("otherModelValue", function() {
                ngModel.$validate();
            });
        }
    };
})
.directive('selectDay', function() {
    var options = '';

    for(var currentDay = 1; currentDay <= 31; currentDay++) {
        var zero = '';
        if(currentDay < 10) {
            zero = '0';
        }
		options = options + '<option value="'+zero+currentDay+'">'+zero+currentDay+'</option>';
	}

    return {
        restrict: 'E',
        template:
                '<select name="nascimento.diaField" ng-model="nascimento.dia">' + options + '</select>'
    };
})


.directive('selectMonth', function() {
    var options = '';

    for(var currentMonth = 1; currentMonth <= 12; currentMonth++) {
        var zero = '';
        if(currentMonth < 10) {
            zero = '0';
        }
        options = options + '<option value="'+zero+currentMonth+'">'+zero+currentMonth+'</option>';
    }

    return {
        restrict: 'E',
        template:
                '<select required name="nascimento.mesField" ng-model="nascimento.mes">' + options + '</select>'
    };
})


.directive('selectYear', function() {
    var options = '';
    var currentDate = new Date();
    var currentYear = currentDate.getFullYear() - 17;

    for(var i = 100; i >= 0; i--, currentYear--) {
        var zero = '';
        if(currentYear < 10) {
            zero = '0';
        }
        options = options + '<option value="'+zero+currentYear+'">'+zero+currentYear+'</option>';
    }

    return {
        restrict: 'E',
        template:
                '<select required name="nascimento.anoField" ng-model="nascimento.ano">' + options + '</select>'
    };
});
