angular.module('iclan.factories', [])

.factory("externalFactory", ['$http', 'LINK', function($http, LINK) {
    var config = {
        defaultUrl: LINK,
        defaultHeader: {
            'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8',
            'Api-Key': '2d18e6249c7509a80e0d1d419e198486'
        }
    }

    return {
        post: function(path, dataSend, method, headers) {

            return $http({
                url: config.defaultUrl + path,
                data: dataSend,
                method: method,
                headers: config.defaultHeader
            });
        }
    };
}])


.factory('localFactory', function() {
    return {
        set: function(name, data) {
            localStorage.setItem('br.com.iclan_' + name, JSON.stringify(data));
            return true;
        },
        get: function(name) {
            return JSON.parse(localStorage.getItem('br.com.iclan_' + name));
        },
        delete: function(name) {
            return localStorage.removeItem('br.com.iclan_' + name);
        },
        clear: function() {
            return localStorage.clear();
        }
    };
})


.factory('registerFactory', ['$ionicPopup', 'localFactory', 'externalFactory', 'platform', 'versionOS', 'versionApp', function($ionicPopup, localFactory, externalFactory, platform, versionOS, versionApp) {
    return {
        saveID: function(IdAparelho) {
            var data = {
                key: localFactory.get("key"),
                IdPessoa: localFactory.get("Dados.IdPessoa"),
                RegisterID: IdAparelho,
                Plataforma: platform,
                VersaoOS: versionOS,
                VersaoApp: versionApp
            };
            console.log(IdAparelho);
            if (IdAparelho != 'OK') {
                externalFactory.post("/guarda-register-id", data, "options")

                .error(function(error) {

                    $ionicPopup.alert({
                        title: "Atenção",
                        template: "Não foi possível conectar-se ao servidor."
                    });

                }).success(function(retorno) {
                    console.log(retorno);
                    if (retorno.Mensagem != "OK") {
                        $ionicPopup.alert({
                            title: "Atenção",
                            template: retorno.Mensagem
                        });
                    } else {
                        localFactory.set("RegisterID", IdAparelho);
                    }
                });
            }
        }
    }
}])

.factory('backButtonFactory', ['$rootScope', '$window', 'localFactory', function($rootScope, $window, localFactory) {
    return {
        setHash: function(hash) {
            $rootScope.setHash(hash);
        },
        removeHash: function() {
            $rootScope.setHash("");
        }
    };
}]);
