angular.module('iclan.services', [])

.service('pushNotification', ['$rootScope', '$ionicPopup', '$cordovaPush', 'localFactory', 'platform', 'registerFactory',

    function($rootScope, $ionicPopup, $cordovaPush, localFactory, platform, registerFactory) {

        $rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
            switch (platform) {
                case "I":
                    switch (notification.redirect) {
                        case "semHabilitacao1":
                            localFactory.set("Dados.Habilitacao", "N");
                            localFactory.set("Tab", 1);
                            break;
                        case "semHabilitacao2":
                            localFactory.set("Dados.Habilitacao", "N");
                            localFactory.set("Tab", 2);
                            break;
                        case "semHabilitacao3":
                            localFactory.set("Dados.Habilitacao", "N");
                            localFactory.set("Tab", 3);
                            break;
                        case "comHabilitacao1":
                            localFactory.set("Dados.Habilitacao", "S");
                            localFactory.set("Tab", 1);
                            break;
                        case "comHabilitacao2":
                            localFactory.set("Dados.Habilitacao", "S");
                            localFactory.set("Tab", 2);
                            break;
                    }

                    var page = notification.redirect;
                    page = page.substring(0, page.length - 1);
                    $rootScope.go("/" + page);
                    break;

                case "A":
                    switch (notification.event) {
                        case "registered":
                            registerFactory.saveID(notification.regid);
                            localFactory.set("RegisterID", notification.regid);
                            break;
                        case "message":
                            switch (notification.payload.tickerText) {
                                case "semHabilitacao1":
                                    localFactory.set("Dados.Habilitacao", "N");
                                    localFactory.set("Tab", 1);
                                    break;
                                case "semHabilitacao2":
                                    localFactory.set("Dados.Habilitacao", "N");
                                    localFactory.set("Tab", 2);
                                    break;
                                case "semHabilitacao3":
                                    localFactory.set("Dados.Habilitacao", "N");
                                    localFactory.set("Tab", 3);
                                    break;
                                case "comHabilitacao1":
                                    localFactory.set("Dados.Habilitacao", "S");
                                    localFactory.set("Tab", 1);
                                    break;
                                case "comHabilitacao2":
                                    localFactory.set("Dados.Habilitacao", "S");
                                    localFactory.set("Tab", 2);
                                    break;
                            }

                            var page = notification.payload.tickerText;
                            page = page.substring(0, page.length - 1);
                            $rootScope.go("/" + page);

                            break;
                        case "error":
                            $ionicPopup.alert({
                                title: "Ocorreu um erro no servi?o de mensagens: " + notification.msg
                            });
                            break;
                        default:
                            $ionicPopup.alert({
                                title: "Um evento GCM desconhecido ocorreu."
                            });
                            break;
                    }
                    break;
            }

        });

    }
])


.service('setBackButton', function($ionicPlatform, $rootScope, localFactory) {
    this.deregister = undefined;

    this.init = function() {
        this.deregister = $ionicPlatform.registerBackButtonAction(function(e) {

            if (localFactory.get("Pagina") != "novaCNH" &&
                localFactory.get("Pagina") != "novoCarro" &&
                localFactory.get("Pagina") != "configuracao" &&
                localFactory.get("Pagina") != "perfil") {
                e.preventDefault();
                ionic.Platform.exitApp();
                return false;
            } else {
                $rootScope.back();
            }
        }, 101);
    }
});
